unit FormMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, ActiveX,
  VirtualTrees,
  RichEdit, JvRichEdit, NanaRichEdit,
  JvDockTree, JvDockControlForm, JvDockVIDStyle, JvDockVSNetStyle,
  JvComponentBase, JvExControls, JvComponent, JvEmbeddedForms,
  Mask, JvExMask,
  JvToolEdit, ToolWin, ThemeMgr, ActnList, TBXSwitcher, TB2Item,
  TB2Dock, TB2Toolbar, ImgList, TBX, ExtDlgs, JvExStdCtrls, JvCombobox,
  JvColorCombo, TBXToolPals, TBXExtItems, TB2MRU, AppEvnts, Menus, TBXLists,
  SPIs;

type

  TMainForm = class(TForm)
    JvDockServer: TJvDockServer;
    JvDockVSNetStyle: TJvDockVSNetStyle;
    JvEmbeddedFormPanel: TJvEmbeddedFormPanel;
    TitlePanel: TPanel;
    SubToolbarPanel: TPanel;
    StateToolBar: TToolBar;
    StateButton: TToolButton;
    EditTitle: TJvComboEdit;
    PanelClient: TPanel;
    PanelTopSpacer: TPanel;
    PanelRightSpacer: TPanel;
    MainActionList: TActionList;
    ActionNew: TAction;
    ActionOpen: TAction;
    ActionSave: TAction;
    ActionSaveAs: TAction;
    ActionAbout: TAction;
    ActionPagePrint: TAction;
    ActionDocPrint: TAction;
    ActionExit: TAction;
    ActionFind: TAction;
    ActionFindPrev: TAction;
    ActionFindNext: TAction;
    ActionFindReplace: TAction;
    ActionExportPage: TAction;
    ActionExportDoc: TAction;
    ActionNaviPrev: TAction;
    ActionNaviNext: TAction;
    ActionAddFromFile: TAction;
    ActionShowMainToolBar: TAction;
    ActionShowFormatToolBar: TAction;
    ActionShowTreeToolBar: TAction;
    ActionShowTitleBar: TAction;
    ActionShowRuler: TAction;
    ActionShowStatusBar: TAction;
    DockTop: TTBXDock;
    MenuToolbar: TTBXToolbar;
    TBXSwitcher: TTBXSwitcher;
    mnuTree: TTBXSubmenuItem;
    mnuFile: TTBXSubmenuItem;
    mnuEdit: TTBXSubmenuItem;
    mnuSearch: TTBXSubmenuItem;
    mnuFormat: TTBXSubmenuItem;
    mnuTool: TTBXSubmenuItem;
    mnuHelp: TTBXSubmenuItem;
    MainToolbar: TTBXToolbar;
    DockLeft: TTBXDock;
    DockRight: TTBXDock;
    DockBottom: TTBXDock;
    TreeToolbar: TTBXToolbar;
    mnuView: TTBXSubmenuItem;
    TBXItem1: TTBXItem;
    TBXItem2: TTBXItem;
    TBXItem3: TTBXItem;
    TBXSeparatorItem1: TTBXSeparatorItem;
    TBXItem4: TTBXItem;
    TBXItem5: TTBXItem;
    TBXItem6: TTBXItem;
    TBXItem7: TTBXItem;
    TBXSeparatorItem2: TTBXSeparatorItem;
    TBXItem8: TTBXItem;
    TBXItem9: TTBXItem;
    TBXItem10: TTBXItem;
    TBXSeparatorItem3: TTBXSeparatorItem;
    TBXSeparatorItem4: TTBXSeparatorItem;
    TBXItem11: TTBXItem;
    TBXItem12: TTBXItem;
    TBXSeparatorItem5: TTBXSeparatorItem;
    MainImageList: TImageList;
    StatusBar: TStatusBar;
    mnuFileNew: TTBXItem;
    mnuFileOpen: TTBXItem;
    mnuFileMRU: TTBXSubmenuItem;
    mnuFileSave: TTBXItem;
    mnuFileSaveAs: TTBXItem;
    TBXSeparatorItem6: TTBXSeparatorItem;
    mnuFileExport: TTBXSubmenuItem;
    TBXSeparatorItem7: TTBXSeparatorItem;
    TBXSeparatorItem8: TTBXSeparatorItem;
    mnuFilePrint: TTBXSubmenuItem;
    mnuFileExit: TTBXItem;
    TBXSeparatorItem9: TTBXSeparatorItem;
    mnuSearchFind: TTBXItem;
    mnuSearchFindNext: TTBXItem;
    mnuSearchFindPrev: TTBXItem;
    TBXSeparatorItem10: TTBXSeparatorItem;
    mnuSearchFindReplace: TTBXItem;
    mnuToolSetting: TTBXItem;
    ActionSetting: TAction;
    ActionKeySetting: TAction;
    mnuToolKeySetting: TTBXItem;
    mnuHelpAbout: TTBXItem;
    mnuTreeInsertNode: TTBXItem;
    mnuTreeAddNode: TTBXItem;
    mnuTreeAddChildNode: TTBXItem;
    TBXSeparatorItem11: TTBXSeparatorItem;
    mnuTreeMovePrev: TTBXItem;
    mnuTreeMoveNext: TTBXItem;
    mnuTreeMoveUp: TTBXItem;
    mnuTreeMoveDown: TTBXItem;
    TBXSeparatorItem12: TTBXSeparatorItem;
    mnuTreeDeleteNode: TTBXItem;
    TBXSeparatorItem13: TTBXSeparatorItem;
    mnuTreeExpandAll: TTBXItem;
    TBXSeparatorItem14: TTBXSeparatorItem;
    mnuTreeMergeNode: TTBXItem;
    mnuTreeSplitNode: TTBXItem;
    TBXSeparatorItem15: TTBXSeparatorItem;
    mnuTreeSortNode: TTBXItem;
    mnuEditUndo: TTBXItem;
    mnuEditRedo: TTBXItem;
    TBXSeparatorItem16: TTBXSeparatorItem;
    mnuEditCopy: TTBXItem;
    mnuEditCut: TTBXItem;
    mnuEditPaste: TTBXItem;
    TBXSeparatorItem17: TTBXSeparatorItem;
    mnuEditFormatPaste: TTBXItem;
    TBXSeparatorItem18: TTBXSeparatorItem;
    mnuEditSelectAll: TTBXItem;
    mnuInsert: TTBXSubmenuItem;
    mnuInsertLink: TTBXItem;
    mnuInsertPicture: TTBXItem;
    mnuInsertObject: TTBXItem;
    mnuInsertTable: TTBXItem;
    mnuFormatFont: TTBXItem;
    mnuFormatFontStyle: TTBXSubmenuItem;
    TBXSeparatorItem19: TTBXSeparatorItem;
    mnuFormatBold: TTBXItem;
    mnuFormatItalic: TTBXItem;
    mnuFormatStrikeout: TTBXItem;
    mnuFormatUnderline: TTBXItem;
    TBXSeparatorItem20: TTBXSeparatorItem;
    mnuFormatSuperScript: TTBXItem;
    mnuFormatSubScript: TTBXItem;
    TBXSeparatorItem21: TTBXSeparatorItem;
    mnuFormatAlignLeft: TTBXItem;
    mnuFormatAlignCenter: TTBXItem;
    mnuFormatAlignRight: TTBXItem;
    TBXSeparatorItem22: TTBXSeparatorItem;
    mnuFormatBullets: TTBXItem;
    mnuFormatNumbering: TTBXItem;
    OpenPictureDialog: TOpenPictureDialog;
    FontDialog: TFontDialog;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    ExportPageDialog: TSaveDialog;
    ExportDocDialog: TSaveDialog;
    TBXItem13: TTBXItem;
    TBXSubmenuItem1: TTBXSubmenuItem;
    TBXSeparatorItem23: TTBXSeparatorItem;
    TBXItem14: TTBXItem;
    TBXItem15: TTBXItem;
    TBXSeparatorItem24: TTBXSeparatorItem;
    SubmenuItemNaviPrev: TTBXSubmenuItem;
    SubmenuItemNaviNext: TTBXSubmenuItem;
    TBXSeparatorItem25: TTBXSeparatorItem;
    TBXItem16: TTBXItem;
    TBXItem17: TTBXItem;
    TBXSeparatorItem26: TTBXSeparatorItem;
    TBXItem18: TTBXItem;
    TBXItem19: TTBXItem;
    TBXItem20: TTBXItem;
    TBXSeparatorItem27: TTBXSeparatorItem;
    TBXItem21: TTBXItem;
    TBXItem22: TTBXItem;
    ActionCopy: TAction;
    ActionCut: TAction;
    ActionPaste: TAction;
    ActionFormatPaste: TAction;
    ActionSelectAll: TAction;
    FormatToolbar: TTBXToolbar;
    SubmenuItemFontStyle: TTBXSubmenuItem;
    TBControlItem1: TTBControlItem;
    FontComboBox: TJvFontComboBox;
    TBControlItem2: TTBControlItem;
    FontSizeComboBox: TComboBox;
    TBXSeparatorItem28: TTBXSeparatorItem;
    TBXSeparatorItem29: TTBXSeparatorItem;
    TBXSeparatorItem30: TTBXSeparatorItem;
    SubmenuItemColor: TTBXSubmenuItem;
    ColorPalette: TTBXColorPalette;
    TBXSeparatorItem31: TTBXSeparatorItem;
    TBXDockInner: TTBXDock;
    TBXItem23: TTBXItem;
    TBXItem24: TTBXItem;
    TBXItem25: TTBXItem;
    TBXItem26: TTBXItem;
    TBXSeparatorItem32: TTBXSeparatorItem;
    TBXItem27: TTBXItem;
    TBXItem28: TTBXItem;
    TBXSeparatorItem33: TTBXSeparatorItem;
    TBXItem29: TTBXItem;
    TBXItem30: TTBXItem;
    TBXItem31: TTBXItem;
    TBXSeparatorItem34: TTBXSeparatorItem;
    TBXItem32: TTBXItem;
    TBXItem33: TTBXItem;
    ActionDelete: TAction;
    ThemeManager: TThemeManager;
    PanelRight: TPanel;
    PanelBottom: TPanel;
    PanelLeft: TPanel;
    MRUList: TTBXMRUList;
    MRUListItem: TTBXMRUListItem;
    TBXSubmenuItem5: TTBXSubmenuItem;
    TBXItem34: TTBXItem;
    TBXItem35: TTBXItem;
    TBXItem36: TTBXItem;
    TBXItem37: TTBXItem;
    TBXItem38: TTBXItem;
    TBXItem39: TTBXItem;
    TBXItem40: TTBXItem;
    TBXItem41: TTBXItem;
    TBXItem42: TTBXItem;
    TBXItem43: TTBXItem;
    ApplicationEvents: TApplicationEvents;
    TBXItem45: TTBXItem;
    TBXItem46: TTBXItem;
    TBXSeparatorItem36: TTBXSeparatorItem;
    TBXItem47: TTBXItem;
    TBXItem48: TTBXItem;
    TBXItem49: TTBXItem;
    TBXItem50: TTBXItem;
    ActionTreeMergeNode: TAction;
    ActionTreeSplitNode: TAction;
    SubmenuItemImage: TTBXSubmenuItem;
    TBXSeparatorItem37: TTBXSeparatorItem;
    ImagePopupMenu: TTBXPopupMenu;
    ActionListImage: TActionList;
    ActionNoImage: TAction;
    ActionImage1: TAction;
    TBXItem51: TTBXItem;
    TBXItem52: TTBXItem;
    StateImageList: TImageList;
    ActionImage2: TAction;
    ActionImage3: TAction;
    ActionImage4: TAction;
    ActionImage5: TAction;
    ActionImage6: TAction;
    ActionImage7: TAction;
    ActionImage8: TAction;
    TBXItem53: TTBXItem;
    TBXItem54: TTBXItem;
    TBXItem55: TTBXItem;
    TBXItem56: TTBXItem;
    TBXItem57: TTBXItem;
    TBXItem58: TTBXItem;
    TBXItem59: TTBXItem;
    TBXSeparatorItem38: TTBXSeparatorItem;
    FontStyleActionList: TActionList;
    ActionFontStyleSetting: TAction;
    ActionFontStyleNoChangeFont: TAction;
    ActionFontStyle0: TAction;
    ActionFontStyle1: TAction;
    ActionFontStyle2: TAction;
    ActionFontStyle3: TAction;
    ActionFontStyle4: TAction;
    ActionFontStyle5: TAction;
    ActionFontStyle6: TAction;
    ActionFontStyle7: TAction;
    ActionFontStyle8: TAction;
    ActionFontStyle9: TAction;
    ActionFontStyle10: TAction;
    ActionFontStyle11: TAction;
    ActionFontStyle12: TAction;
    ActionFontStyle13: TAction;
    ActionFontStyle14: TAction;
    ActionFontStyle15: TAction;
    FontStylePopupMenu: TTBXPopupMenu;
    TBXItem60: TTBXItem;
    TBXItem61: TTBXItem;
    TBXItem62: TTBXItem;
    TBXItem63: TTBXItem;
    TBXItem64: TTBXItem;
    TBXItem65: TTBXItem;
    TBXItem66: TTBXItem;
    TBXItem67: TTBXItem;
    TBXItem68: TTBXItem;
    TBXItem69: TTBXItem;
    TBXItem70: TTBXItem;
    TBXItem71: TTBXItem;
    TBXItem72: TTBXItem;
    TBXItem73: TTBXItem;
    TBXItem74: TTBXItem;
    TBXItem75: TTBXItem;
    TBXSeparatorItem39: TTBXSeparatorItem;
    TBXItem76: TTBXItem;
    TBXSeparatorItem40: TTBXSeparatorItem;
    TBXItem77: TTBXItem;
    SPIs: TSPIs;
    TreePopupMenu: TTBXPopupMenu;
    EditorPopupMenu: TTBXPopupMenu;
    ItemOtherColor: TTBXItem;
    ColorDialog: TColorDialog;
    TBXSeparatorItem41: TTBXSeparatorItem;
    ItemDefaultColor: TTBXColorItem;
    TBXItem78: TTBXItem;
    TBXItem79: TTBXItem;
    TBXItem80: TTBXItem;
    TBXSeparatorItem42: TTBXSeparatorItem;
    TBXItem81: TTBXItem;
    TBXSubmenuItem6: TTBXSubmenuItem;
    TBXItem82: TTBXItem;
    TBXItem83: TTBXItem;
    TBXItem84: TTBXItem;
    TBXItem85: TTBXItem;
    TBXItem86: TTBXItem;
    TBXItem87: TTBXItem;
    TBXItem88: TTBXItem;
    TBXItem89: TTBXItem;
    TBXItem90: TTBXItem;
    TBXSeparatorItem43: TTBXSeparatorItem;
    TBXItem91: TTBXItem;
    TBXItem92: TTBXItem;
    TBXItem93: TTBXItem;
    TBXItem94: TTBXItem;
    TBXSeparatorItem44: TTBXSeparatorItem;
    TBXItem95: TTBXItem;
    TBXItem96: TTBXItem;
    TBXItem97: TTBXItem;
    TBXItem98: TTBXItem;
    TBXSeparatorItem45: TTBXSeparatorItem;
    TBXItem99: TTBXItem;
    TBXSeparatorItem46: TTBXSeparatorItem;
    TBXItem100: TTBXItem;
    TBXSeparatorItem47: TTBXSeparatorItem;
    TBXItem101: TTBXItem;
    TBXItem102: TTBXItem;
    TBXSeparatorItem48: TTBXSeparatorItem;
    TBXItem103: TTBXItem;
    mnuPrevFocus: TTBXItem;
    mnuNextFocus: TTBXItem;
    TBXSeparatorItem35: TTBXSeparatorItem;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionNewExecute(Sender: TObject);
    procedure ActionOpenExecute(Sender: TObject);
    procedure MRUListClick(Sender: TObject; const Filename: String);
    procedure ActionSaveExecute(Sender: TObject);
    procedure ActionSaveUpdate(Sender: TObject);
    procedure ActionSaveAsExecute(Sender: TObject);
    procedure ActionExportPageExecute(Sender: TObject);
    procedure ExportPageDialogTypeChange(Sender: TObject);
    procedure ActionExportDocExecute(Sender: TObject);
    procedure ExportDocDialogTypeChange(Sender: TObject);
    procedure ActionPagePrintExecute(Sender: TObject);
    procedure ActionDocPrintExecute(Sender: TObject);
    procedure ActionExitExecute(Sender: TObject);
    procedure ActionAddFromFileExecute(Sender: TObject);
    procedure ActionCopyExecute(Sender: TObject);
    procedure ActionCopyUpdate(Sender: TObject);
    procedure ActionCutExecute(Sender: TObject);
    procedure ActionCutUpdate(Sender: TObject);
    procedure ActionPasteExecute(Sender: TObject);
    procedure ActionPasteUpdate(Sender: TObject);
    procedure ActionFormatPasteExecute(Sender: TObject);
    procedure ActionFormatPasteUpdate(Sender: TObject);
    procedure ActionSelectAllExecute(Sender: TObject);
    procedure ActionSelectAllUpdate(Sender: TObject);
    procedure ActionShowMainToolBarExecute(Sender: TObject);
    procedure ActionShowMainToolBarUpdate(Sender: TObject);
    procedure ActionShowFormatToolBarExecute(Sender: TObject);
    procedure ActionShowFormatToolBarUpdate(Sender: TObject);
    procedure ActionShowTreeToolBarExecute(Sender: TObject);
    procedure ActionShowTreeToolBarUpdate(Sender: TObject);
    procedure ActionShowTitleBarExecute(Sender: TObject);
    procedure ActionShowTitleBarUpdate(Sender: TObject);
    procedure ActionShowRulerExecute(Sender: TObject);
    procedure ActionShowRulerUpdate(Sender: TObject);
    procedure ActionShowStatusBarExecute(Sender: TObject);
    procedure ActionShowStatusBarUpdate(Sender: TObject);
    procedure ActionAboutExecute(Sender: TObject);
    procedure SubmenuItemColorDrawImage(Item: TTBCustomItem;
      Viewer: TTBItemViewer; Canvas: TCanvas; ImageRect: TRect;
      ImageOffset: TPoint; StateFlags: Integer);
    procedure FontComboBoxChange(Sender: TObject);
    procedure FontSizeComboBoxChange(Sender: TObject);
    procedure SubmenuItemColorClick(Sender: TObject);
    procedure ApplicationEventsHint(Sender: TObject);
    procedure ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
    procedure EditTitleChange(Sender: TObject);
    procedure ActionTreeMergeNodeExecute(Sender: TObject);
    procedure ActionTreeMergeNodeUpdate(Sender: TObject);
    procedure ActionTreeSplitNodeExecute(Sender: TObject);
    procedure ActionNaviPrevExecute(Sender: TObject);
    procedure ActionNaviNextExecute(Sender: TObject);
    procedure SubmenuItemNaviPopup(Sender: TTBCustomItem;
      FromLink: Boolean);
    procedure ActionImageExecute(Sender: TObject);
    procedure ActionSettingExecute(Sender: TObject);
    procedure ActionFontStyleNoChangeFontExecute(Sender: TObject);
    procedure ActionFontStyleExecute(Sender: TObject);
    procedure ActionFontStyleSettingExecute(Sender: TObject);
    procedure ActionKeySettingExecute(Sender: TObject);
    procedure ApplicationEventsMessage(var Msg: tagMSG;
      var Handled: Boolean);
    procedure ActionFindExecute(Sender: TObject);
    procedure ActionFindPrevExecute(Sender: TObject);
    procedure ActionFindPrevUpdate(Sender: TObject);
    procedure ActionFindNextExecute(Sender: TObject);
    procedure ActionFindNextUpdate(Sender: TObject);
    procedure ActionFindReplaceExecute(Sender: TObject);
    procedure ItemOtherColorClick(Sender: TObject);
    procedure ItemDefaultColorClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

  private
    { Private 錾 }
    FModified: Boolean;     // ύXꂽǂ̃tO
    FFileName: TFileName;   // ҏW̃t@C
    FInNavigate: Boolean;   // irQ[gǂ̃tO
    FUserFonts: array[0..15] of TFont;
    FUseMemory : Boolean;
    FStream: TMemoryStream;

    // ANZT֐
    function Editor: TNanaRichEdit;
    function TreeView: TVirtualStringTree;
    // NanaTreeݒǂݍ
    procedure LoadSetting;
    // tHgX^Cǂݍ
    procedure LoadFontStyles;
    // L[tǂݍ
    procedure LoadKeyBind;
    // m[hLvVT
    function  FindNodeFromCaption(S: String; out Node: PVirtualNode): Boolean;
    // tH[̃LvVɃt@CpX\
    procedure DispFilePath;
    // J[\ʒu\
    procedure UpdateCursorPos;
    // c[r[GfB^̓eo
    procedure LoadFromTree(Sender: TBaseVirtualTree; Node: PVirtualNode);
    // GfB^̓ec[r[ɕۑ
    procedure SaveToTree(Sender: TBaseVirtualTree; Node: PVirtualNode);
    // ύX₢킹
    function  IsModified: Boolean;
    // VK쐬
    procedure CreateNewDocument;
    // t@CJ
    procedure OpenFile(const Path: TFileName);
    // ۑmF
    procedure QuerySaveDocument;
    // Nana`ŕۑ
    procedure SaveNanaFile(const Path: TFileName);
    // hLgŜ̃eLXg쐬
    procedure CreateDocText(SL: TStrings);
    // hLgŜ̃b`eLXg쐬
    procedure CreateDocRichText(SL: TStrings);
    // irQ[g(i/߂)֌W
    function  FindNodeFromNodeNo(No: Integer; out Node: PVirtualNode): Boolean;
    procedure ClearNavigator;
    procedure AddNavigator(Node: PVirtualNode);
    procedure RefreshNaviagator;
    procedure NaviPrevClick(Sender: TObject);
    procedure NaviNextClick(Sender: TObject);
    // 
    procedure FindText(StartPos: Integer);
    // GNX|[g֌W
    procedure RichToHTMLExecute(Edit: TJvRichEdit;
      const Title: String; const FileName: TFileName);
    procedure RichToHTMLExecuteToStringList(Edit: TJvRichEdit;
      SL: TStrings; const Title: String; const FileName: TFileName);
    procedure ExportPageTxt(const Path: TFileName);
    procedure ExportPageRTF(const Path: TFileName);
    procedure ExportPageHTML(const Path: TFileName);
    procedure ExportDocTxt(const Path: TFileName);
    procedure ExportDocTreeTxt(const Path: TFileName);
    procedure ExportDocRTF(const Path: TFileName);
    procedure ExportDocHTML(const Path: TFileName);

  public
    { Public 錾 }
    // c[Ăł炤
    procedure TreeViewFocusChanging(Sender: TBaseVirtualTree;
      OldNode: PVirtualNode; NewNode: PVirtualNode);
    procedure TreeViewFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure TreeViewTextChange(Sender: TBaseVirtualTree; NewText: WideString);
    procedure TreeViewFreeNode(Sender: TBaseVirtualTree);
    procedure TreeViewInsertNode(Sender: TObject);
    // GfB^Ăł炤
    procedure EditorSelectionChange(Sender: TObject);
    procedure JumpToNode(Caption: String);
  end;

var
  MainForm: TMainForm;

implementation

uses
  Jpeg, ShellAPI, Clipbrd, FileCtrl, StrUtils, IniFiles,
  TBXUtils, TBXThemes,
  Ruler, JvAppStorage, JvAppIniStorage,
  ModuleGlobal, FormTree, FormEditor, DlgAbout, FormPrintPreview,
  DlgSetting, DlgEditFontStyle, DlgKeyBind, DlgFind;


{$R *.dfm}


// up
type
  TReplaceCharRec = record
    Before: String;
    After: String;
  end;

const
  ReplaceCharArray: array [1..4] of TReplaceCharRec =
  (
    (Before: '&'; After: '&amp;'),
    (Before: '"'; After: '&quot;'),
    (Before: '<'; After: '&lt;'),
    (Before: '>'; After: '&gt;')
  );


// Fup
type
  TReplaceColorRec = record
    Before: TColor;
    After: String;
  end;

const
  ReplaceColorArray: array [1..46] of TReplaceColorRec =
  (
    // DelphiɂHTMLɂ`ĂF́APɃ}bsO
    (Before: clBlack;  After: 'black'),
    (Before: clWhite;  After: 'white'),
    (Before: clRed;    After: 'red'),
    (Before: clYellow; After: 'yellow'),
    (Before: clBlue;   After: 'blue'),
    (Before: clGreen;  After: 'green'),
    (Before: clGray;   After: 'gray'),
    (Before: clSilver; After: 'silver'),
    (Before: clLime;   After: 'lime'),
    (Before: clTeal;   After: 'teal'),
    (Before: clFuchsia;After: 'fuchsia'),
    (Before: clMaroon; After: 'maroon'),
    (Before: clAqua;   After: 'aqua'),
    (Before: clPurple; After: 'purple'),
    (Before: clOlive;  After: 'olive'),
    (Before: clNavy;   After: 'navy'),
    // Delphiɂ`ĂȂF́AHTMLőΉFRGBw
    (Before: clMoneyGreen; After: '#C0DCC0'),
    (Before: clSkyBlue;    After: '#F0CAA6'),
    (Before: clCream;      After: '#F0FBFF'),
    (Before: clMedGray;    After: '#A4A0A0'),
    // VXeJ[͍Ƀ}bsO
    (Before: clNone; After: 'black'),
    (Before: clScrollBar; After: 'black'),
    (Before: clBackground; After: 'black'),
    (Before: clAppWorkSpace; After: 'black'),
    (Before: clWindow;  After: 'black'),
    (Before: clActiveCaption; After: 'black'),
    (Before: clCaptionText; After: 'black'),
    (Before: clActiveBorder; After: 'black'),
    (Before: clInactiveCaption; After: 'black'),
    (Before: clInactiveCaptionText; After: 'black'),
    (Before: clInactiveBorder; After: 'black'),
    (Before: clMenu; After: 'black'),
    (Before: clMenuText; After: 'black'),
    (Before: clWindowFrame; After: 'black'),
    (Before: clWindowText; After: 'black'),
    (Before: clHighlight; After: 'black'),
    (Before: clHighlightText; After: 'black'),
    (Before: clGrayText; After: 'black'),
    (Before: clBtnHighlight; After: 'black'),
    (Before: cl3DLight; After: 'black'),
    (Before: clBtnFace; After: 'black'),
    (Before: clBtnShadow; After: 'black'),
    (Before: cl3DDkShadow; After: 'black'),
    (Before: clBtnText; After: 'black'),
    (Before: clInfoText; After: 'black'),
    (Before: clInfoBk; After: 'black')
  );


//----------------------------------------
// c[r[̃tH[JXω钼Ȍ
//----------------------------------------
procedure TMainForm.TreeViewFocusChanging(Sender: TBaseVirtualTree;
  OldNode: PVirtualNode; NewNode: PVirtualNode);
begin
  SaveToTree(Sender, OldNode);
  if Editor.Modified then FModified := True;

  if (OldNode <> NewNode) and Assigned(OldNode) then
  begin
    AddNavigator(OldNode);
  end;
end;


//----------------------------------------
// c[r[̃tH[JXωƂ̏
//----------------------------------------
procedure TMainForm.TreeViewFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode);
begin
  LoadFromTree(Sender, Node);

  if Assigned(Node) then
  begin
    EditTitle.OnChange := nil;
    EditTitle.Text := TreeView.Text[Node, 0];
    EditTitle.OnChange := EditTitleChange;

    Editor.Modified := False;
  end;
  EditorForm.EditorSelectionChange(Sender);
end;


//----------------------------------------
// m[h̃eLXgύXƂ̏
//----------------------------------------
procedure TMainForm.TreeViewTextChange(Sender: TBaseVirtualTree; NewText: WideString);
begin
  EditTitle.OnChange := nil;
  EditTitle.Text := NewText;
  EditTitle.OnChange := EditTitleChange;
end;


//----------------------------------------
// m[h폜Ƃ̏
//----------------------------------------
procedure TMainForm.TreeViewFreeNode(Sender: TBaseVirtualTree);
begin
  RefreshNaviagator;
end;


//----------------------------------------
// m[hǉ/}ꂽƂ̏
//----------------------------------------
procedure TMainForm.TreeViewInsertNode(Sender: TObject);
begin
  GlobalModule.IniStorage.Path := 'Tree';
  if True = GlobalModule.IniStorage.ReadBoolean('TreeEdit', True) then
  begin
    if TreeView.CanFocus then
    begin
      TreeView.EditNode(TreeView.FocusedNode, -1);
    end;
  end;
end;


//----------------------------------------
// GfB^̑I͈͂ύXꂽƂ̏
//----------------------------------------
procedure TMainForm.EditorSelectionChange(Sender: TObject);
begin
  if caSize in Editor.SelAttributes.ConsistentAttributes then
  begin
    FontSizeComboBox.Text := IntToStr(Editor.SelAttributes.Size);
  end
  else
  begin
    FontSizeComboBox.Text := '';
  end;

  if caFace in Editor.SelAttributes.ConsistentAttributes then
  begin
    FontComboBox.FontName := Editor.SelAttributes.Name;
  end
  else
  begin
    FontComboBox.ClearSelection;
  end;

  UpdateCursorPos;
end;


//----------------------------------------
// NanaTreeݒǂݍ
//----------------------------------------
procedure TMainForm.LoadSetting;
var
  FStyle: TFontStyles;
  Fs :Byte absolute FStyle;
  Ini: TJvAppIniFileStorage;
begin
  Ini := GlobalModule.IniStorage;
  Ini.Reload;

  Ini.Path := 'General';
  begin
    // gpIvVǂݍ
    FUseMemory := GlobalModule.IniStorage.ReadBoolean('UseMemory', False);
  end;

  // GfB^ݒǂݍ
  Ini.Path := 'Editor';
  begin
    // ڐPʓǂݍ 1.02Ŕp~
    //EditorForm.Ruler.UnitsDisplay := TRulerUnits(Ini.ReadInteger('Unit', 1));
    //EditorForm.Ruler.UnitsProgram := EditorForm.Ruler.UnitsDisplay;

    // TABL[œ͂邩ǂǂݍ 1.02
    Editor.WantTabs := Ini.ReadBoolean('TabInput', False);

    // ڐɍ킹邩ǂǂݍ
    if Ini.ReadBoolean('SnapRuler', True) then
    begin
      EditorForm.Ruler.MarginSettings.Options :=
        EditorForm.Ruler.MarginSettings.Options + [moSnapToRuler];

      EditorForm.Ruler.IndentSettings.Options :=
        EditorForm.Ruler.IndentSettings.Options + [ioSnapToRuler];

      EditorForm.Ruler.TabSettings.Options :=
        EditorForm.Ruler.TabSettings.Options + [toSnapToRuler];
    end
    else
    begin
      EditorForm.Ruler.MarginSettings.Options :=
        EditorForm.Ruler.MarginSettings.Options - [moSnapToRuler];

      EditorForm.Ruler.IndentSettings.Options :=
        EditorForm.Ruler.IndentSettings.Options - [ioSnapToRuler];

      EditorForm.Ruler.TabSettings.Options :=
        EditorForm.Ruler.TabSettings.Options - [toSnapToRuler];
    end;

    // tHgݒǂݍ
    Editor.Font.Name := Ini.ReadString('FontName', DEFAULT_FONT_NAME);
    Editor.Font.Size := Ini.ReadInteger('FontSize', DEFAULT_FONT_SIZE);
    Editor.Font.Color := Ini.ReadInteger('FontColor', DEFAULT_FONT_COLOR);
    Fs := Ini.ReadInteger('FontStyle', 0);
    Editor.Font.Style := FStyle;

    // {^ɊFݒ
    ItemDefaultColor.Color := Editor.Font.Color;

    // [hbvǂݍ
    Editor.WordWrap := Ini.ReadBoolean('WordWrap', True);

    // OLEIuWFNgҏWݒǂݍ
    Editor.AllowInPlace := Ini.ReadBoolean('InplaceEditOLE', False);

    // ꕶ\ݒǂݍ
    Editor.EditMarks.EofMark.Enabled := Ini.ReadBoolean('ShowEOF', False);
    Editor.EditMarks.TabMark.Enabled := Ini.ReadBoolean('ShowTab', False);
    Editor.EditMarks.CrlfMark.Enabled := Ini.ReadBoolean('ShowEnter', False);
    Editor.EditMarks.LineMark.Enabled := Editor.EditMarks.CrlfMark.Enabled;
    Editor.EditMarks.SpaceMark.Enabled := Ini.ReadBoolean('ShowSpace', False);

    Editor.EditMarks.EofMark.Color := Ini.ReadInteger('EOFColor', clSilver);
    Editor.EditMarks.TabMark.Color := Ini.ReadInteger('TabColor', clSilver);
    Editor.EditMarks.CrlfMark.Color := Ini.ReadInteger('EnterColor', clSilver);
    Editor.EditMarks.LineMark.Color := Editor.EditMarks.CrlfMark.Color;
    Editor.EditMarks.SpaceMark.Color := Ini.ReadInteger('SpaceColor', clSilver);
  end;

  // c[ݒǂݍ
  Ini.Path := 'Tree';
  begin
    TreeView.Indent := Ini.ReadInteger('Indent', 18);

    if True = Ini.ReadBoolean('FreeSelect', False) then
    begin
      TreeView.TreeOptions.SelectionOptions :=
        TreeView.TreeOptions.SelectionOptions - [toSiblingSelectConstraint];
    end
    else
    begin
      TreeView.TreeOptions.SelectionOptions :=
        TreeView.TreeOptions.SelectionOptions + [toSiblingSelectConstraint];
    end;
  end;
end;


//----------------------------------------
// tHgX^Cǂݍ
//----------------------------------------
procedure TMainForm.LoadFontStyles;
var
  I: Integer;
  Action: TAction;
  FStyle: TFontStyles;
  Fs :Byte absolute FStyle;
begin
  GlobalModule.IniStorage.Reload;
  GlobalModule.IniStorage.Path := 'UserFonts';

  for I := Low(FUserFonts) to High(FUserFonts) do
  begin
    if Assigned(FUserFonts[I]) then
    begin
      FreeAndNil(FUserFonts[I]);
    end;
    FUserFonts[I] := TFont.Create;
  end;

  for I := Low(FUserFonts) to High(FUserFonts) do
  begin
    Action := TAction(FindComponent('ActionFontStyle' + IntToStr(I)));
    if Assigned(Action) then
    begin
      Action.Visible := GlobalModule.IniStorage.ReadBoolean('UserFont' + IntToStr(I) + 'IsUse', False);
      Action.Caption :=
        GlobalModule.IniStorage.ReadString('UserFont' + IntToStr(I) + 'StyleName', '') +
        '(&' + IntToHex(I, 1) + ')';
    end;

    FUserFonts[I].Name := GlobalModule.IniStorage.ReadString('UserFont' + IntToStr(I) + 'Name', DEFAULT_FONT_NAME);
    FUserFonts[I].Size := GlobalModule.IniStorage.ReadInteger('UserFont' + IntToStr(I) + 'Size', DEFAULT_FONT_SIZE);
    FUserFonts[I].Color := GlobalModule.IniStorage.ReadInteger('UserFont' + IntToStr(I) + 'Color', DEFAULT_FONT_COLOR);
    Fs := GlobalModule.IniStorage.ReadInteger('UserFont' + IntToStr(I) + 'Styles', 0);
    FUserFonts[I].Style := FStyle;
  end;
end;


//----------------------------------------
// L[tǂݍ
//----------------------------------------
procedure TMainForm.LoadKeyBind;

  procedure SetKeyBind(Action: TAction);
  var
    S: String;
  begin
    S := GlobalModule.IniStorage.ReadString(Action.Name, ShortCutToText(Action.ShortCut));
    Action.ShortCut := TextToShortCut(S);
  end;

begin
  GlobalModule.IniStorage.Reload;
  GlobalModule.IniStorage.Path := 'KeyBind';

  // t@C
  SetKeyBind(ActionNew);
  SetKeyBind(ActionOpen);
  SetKeyBind(ActionSave);
  SetKeyBind(ActionSaveAs);
  SetKeyBind(ActionExportPage);
  SetKeyBind(ActionExportDoc);
  SetKeyBind(ActionPagePrint);
  SetKeyBind(ActionDocPrint);
  SetKeyBind(ActionExit);

  // ړ
  SetKeyBind(ActionNaviPrev);
  SetKeyBind(ActionNaviNext);
  SetKeyBind(TreeForm.ActionPrevFocus);
  SetKeyBind(TreeForm.ActionNextFocus);

  // c[
  SetKeyBind(TreeForm.ActionInsertNode);
  SetKeyBind(TreeForm.ActionAddNode);
  SetKeyBind(TreeForm.ActionAddChildNode);
  SetKeyBind(ActionAddFromFile);
  SetKeyBind(TreeForm.ActionMovePrev);
  SetKeyBind(TreeForm.ActionMoveNext);
  SetKeyBind(TreeForm.ActionMoveDown);
  SetKeyBind(TreeForm.ActionMoveUp);
  SetKeyBind(TreeForm.ActionCopy);
  SetKeyBind(TreeForm.ActionCut);
  SetKeyBind(TreeForm.ActionPaste);
  SetKeyBind(TreeForm.ActionDeteleNode);
  SetKeyBind(ActionTreeMergeNode);
  SetKeyBind(ActionTreeSplitNode);
  SetKeyBind(TreeForm.ActionExpandAll);
  SetKeyBind(TreeForm.ActionSortNode);

  // ҏW
  SetKeyBind(EditorForm.ActionEditUndo);
  SetKeyBind(EditorForm.ActionEditRedo);
  SetKeyBind(ActionCopy);
  SetKeyBind(ActionCut);
  SetKeyBind(ActionPaste);
  SetKeyBind(ActionFormatPaste);
  SetKeyBind(ActionSelectAll);

  // 
  SetKeyBind(ActionFind);
  SetKeyBind(ActionFindPrev);
  SetKeyBind(ActionFindNext);
  SetKeyBind(ActionFindReplace);

  // }
  SetKeyBind(EditorForm.ActionInsertLink);
  SetKeyBind(EditorForm.ActionInsertPicture);
  SetKeyBind(EditorForm.ActionInsertObject);
  SetKeyBind(EditorForm.ActionInsertTable);

  // 
  SetKeyBind(EditorForm.ActionFontDlg);
  SetKeyBind(EditorForm.ActionBold);
  SetKeyBind(EditorForm.ActionItalic);
  SetKeyBind(EditorForm.ActionUnderline);
  SetKeyBind(EditorForm.ActionStrikeOut);
  SetKeyBind(EditorForm.ActionSuperScript);
  SetKeyBind(EditorForm.ActionSubScript);
  SetKeyBind(EditorForm.ActionAlignLeft);
  SetKeyBind(EditorForm.ActionAlignCenter);
  SetKeyBind(EditorForm.ActionAlignRight);
  SetKeyBind(EditorForm.ActionBullets);
  SetKeyBind(EditorForm.ActionNumbering);
end;


//----------------------------------------
// wm[hֈړ
//----------------------------------------
procedure TMainForm.JumpToNode(Caption: String);
var
  Node: PVirtualNode;
begin
  if FindNodeFromCaption(Caption, Node) then
  begin
    TreeView.ClearSelection;
    TreeView.FocusedNode := Node;
    TreeView.Selected[Node] := True;
    Sleep(300);
    Application.ProcessMessages;
    //Editor.SelStart := 0;
    //Editor.SelLength := 0;
  end
  // Nꂽm[hȂAURLNƂ݂Ȃ
  else
  begin
    ShellExecute(Self.Handle, 'OPEN', PChar(Caption), '', '', SW_SHOW);
  end;
end;


//----------------------------------------
// ANZT֐
//----------------------------------------
function TMainForm.Editor: TNanaRichEdit;
begin
  Result := EditorForm.Editor;
end;

function TMainForm.TreeView: TVirtualStringTree;
begin
  Result := TreeForm.TreeView;
end;


//----------------------------------------
// m[hLvVT
//----------------------------------------
function TMainForm.FindNodeFromCaption(S: String; out Node: PVirtualNode): Boolean;
begin
  Result := False;

  Node := TreeView.RootNode.FirstChild;
  while Assigned(Node) do
  begin
    if TreeForm.NodeData(Node).Caption = S then
    begin
      Result := True;
      Exit;
    end;
    Node := TreeView.GetNext(Node);
  end;
end;


//----------------------------------------
// tH[̃LvVɃt@CpX\
//----------------------------------------
procedure TMainForm.DispFilePath;
var
  FileName: String;
begin
  if FFileName = '' then
  begin
    Self.Caption := 'NanaTree - VK';
  end
  else
  begin
    FileName := MinimizeName(FFileName, Canvas, 300);
    Self.Caption := Format('NanaTree - %s', [FileName]);
  end;
end;


//----------------------------------------
// J[\ʒu̕\XV
//----------------------------------------
procedure TMainForm.UpdateCursorPos;
const
  ColRowInfo = '@%4ds F%4d@(%5d)';
var
  P: Integer;
  X: Integer;
  Y: Integer;
begin
  P := Editor.SelStart;
  Y := Editor.LineFromChar(P);
  X := P - SendMessage(Editor.Handle, EM_LINEINDEX, Y, 0);
  Inc(P);
  Inc(Y);
  Inc(X);
  StatusBar.Panels[2].Text := Format(ColRowInfo, [Y, X, P]);
end;


//----------------------------------------
// c[r[GfB^̓eo
//----------------------------------------
procedure TMainForm.LoadFromTree(Sender: TBaseVirtualTree; Node: PVirtualNode);
var
  Data: PNodeData;
begin
  if not Assigned(Node) then Exit;

  FStream.Position := 0;
  Data := TreeForm.NodeData(Node);

  Editor.Lines.BeginUpdate;
  try
    // Clearł́ARs[Œx_OĂ
    // f[^̎擾sȂ̂ŁAClearSelectiong
    Editor.SelectAll;
    Editor.ClearSelection;
    Editor.Clear;

    Editor.SelAttributes := Editor.DefAttributes;
    Editor.Paragraph.Numbering := nsNone;
    Editor.Paragraph.Alignment := paLeftJustify;

    if Length(Data.Strings.Text) > 0 then
    begin
      Data.Strings.SaveToStream(FStream);
      FStream.Position := 0;
      FStream.Size := Length(Data.Strings.Text);
      Editor.Lines.LoadFromStream(FStream);
      Editor.SelStart := Data.SelStart;
      Editor.SelLength := Data.SelLength;
    end;

    if not FUseMemory then
    begin
      FStream.Clear;
    end;

  finally
    Editor.Lines.EndUpdate;
  end;

  // {^ɃZbg
  Data := TreeForm.NodeData(Node);
  if Data.StateIndex = -1 then
  begin
    StateButton.Action := ActionNoImage;
  end
  else
  begin
    StateButton.Action := FindComponent('ActionImage' + IntToStr(Data.StateIndex + 1)) as TAction;
  end;

end;


//----------------------------------------
// GfB^̓ec[r[ɕۑ
//----------------------------------------
procedure TMainForm.SaveToTree(Sender: TBaseVirtualTree; Node: PVirtualNode);
begin
  if not Assigned(Node) then Exit;

  if Editor.Modified then
  begin
    FStream.Position := 0;
    Editor.Lines.SaveToStream(FStream);
    FStream.Position := 0;
    TreeForm.NodeData(Node).Strings.LoadFromStream(FStream);

    if not FUseMemory then
    begin
      FStream.Clear;
    end;
  end;
  TreeForm.NodeData(Node).SelStart := Editor.SelStart;
  TreeForm.NodeData(Node).SelLength := Editor.SelLength;
end;


//----------------------------------------
// ύX₢킹
//----------------------------------------
function TMainForm.IsModified: Boolean;
begin
  Result := TreeForm.Modified or Editor.Modified or FModified;
end;


//----------------------------------------
// VK쐬
//----------------------------------------
procedure TMainForm.CreateNewDocument;
begin
  TreeForm.NodeNo := 0;
  ClearNavigator;

  TreeView.Clear;
  Editor.Clear;
  Editor.ClearUndo;
  TreeView.AddChild(nil);
  TreeView.FocusedNode := TreeView.GetFirst;
  //TreeView.Selected[TreeView.GetFirst] := True;
  TreeForm.Modified := False;
  Editor.Modified := False;
  FModified := False;

  FFileName := '';
  DispFilePath;
end;


//----------------------------------------
// t@CJ
//----------------------------------------
procedure TMainForm.OpenFile(const Path: TFileName);
var
  Node: PVirtualNode;
begin
  if not FileExists(Path) then
  begin
    MessageDlg('t@C܂łB', mtWarning, [mbOK], 0);
    Exit;
  end;

  QuerySaveDocument;

  FStream.Clear;
  TreeForm.NodeNo := 0;
  ClearNavigator;

  TreeView.Clear;
  Editor.Clear;
  Editor.ClearUndo;

  Node := TreeView.RootNode.FirstChild;

  TreeForm.AddTreeFromFile(Path, Node, amAddChildLast);

  FFileName := Path;
  DispFilePath;
  MRUList.Add(Path);
  TreeForm.Modified := False;
  Editor.Modified := False;
  FModified := False;
  if TreeView.FocusedNode = nil then
  begin
    TreeView.FocusedNode := TreeView.GetFirst;
    //TreeView.Selected[TreeView.FocusedNode] := True;
  end;
end;


//----------------------------------------
// ۑmF
//----------------------------------------
procedure TMainForm.QuerySaveDocument;
var
  Ret: TModalResult;
begin
  if IsModified then
  begin
    Ret := MessageDlg('ݕҏW̕ۑ܂H', mtWarning, mbYesNoCancel, 0);
    if Ret = mrCancel then Abort;
    if Ret = mrYes then ActionSaveExecute(nil);
  end;
end;


//----------------------------------------
// Nana`ŕۑ
//----------------------------------------
procedure TMainForm.SaveNanaFile(const Path: TFileName);
begin
  SaveToTree(TreeView, TreeView.FocusedNode);

  TreeForm.SaveToNanaFile(Path);
end;


//----------------------------------------
// hLgŜ̃eLXg쐬
//----------------------------------------
procedure TMainForm.CreateDocText(SL: TStrings);
var
  Node: PVirtualNode;
  Rich: TJvRichEdit;
  MS: TMemoryStream;

  // 葱(eLXg쐬)
  procedure CreateText(SL: TStrings; Node: PVirtualNode);
  var
    Data: PNodeData;
    ChildNode: PVirtualNode;
  begin
    while Assigned(Node) do
    begin
      Data := TreeForm.NodeData(Node);

      // c[̃LvVoƂĒǉ
      SL.Add('' + Data.Caption);

      // {ǉ
      SL.Add(Copy(Data.Strings.Text, 1, Length(Data.Strings.Text)));
      SL.Add('');

      ChildNode := Node.FirstChild;
      if Assigned(ChildNode) then
      begin
        CreateText(SL, ChildNode);   // ċA
      end;
      Node := Node.NextSibling;
    end;
  end;

begin
  Rich := TJvRichEdit.Create(nil);
  try
    Rich.Visible := False;
    Rich.Parent := Self;
    Rich.StreamFormat := sfPlainText;

    Node := TreeView.RootNode.FirstChild;
    CreateText(Rich.Lines, Node);
    MS := TMemoryStream.Create;
    try
      MS.Position := 0;
      Rich.Lines.SaveToStream(MS);
      MS.Position := 0;
      SL.LoadFromStream(MS);
    finally
      MS.Free;
    end;
  finally
    Rich.Free;
  end;
end;


//----------------------------------------
// hLgŜ̃b`eLXg쐬
//----------------------------------------
procedure TMainForm.CreateDocRichText(SL: TStrings);
var
  Node: PVirtualNode;
  Rich: TJvRichEdit;
  MS: TMemoryStream;

  // 葱(eLXg쐬)
  procedure CreateText(SL: TStrings; Node: PVirtualNode);
  var
    Data: PNodeData;
    ChildNode: PVirtualNode;
  begin
    while Assigned(Node) do
    begin
      Data := TreeView.GetNodeData(Node);

      // c[̃LvVoƂĒǉ
      SL.Add('');
      Rich.SelAttributes.Name := 'lr SVbN';
      Rich.SelAttributes.Size := 12;
      Rich.SelAttributes.Bold := True;
      SL.Add('' + Data.Caption);

      // {ǉ
      SL.Add(Copy(Data.Strings.Text, 1, Length(Data.Strings.Text)));
      SL.Add('');

      ChildNode := Node.FirstChild;
      if Assigned(ChildNode) then
      begin
        CreateText(SL, ChildNode);   // ċA
      end;
      Node := Node.NextSibling;
    end;
  end;

begin
  Rich := TJvRichEdit.Create(nil);
  try
    Rich.Visible := False;
    Rich.Parent := Self;
    Rich.StreamFormat := sfRichText;

    Node := TreeView.RootNode.FirstChild;
    CreateText(Rich.Lines, Node);
    MS := TMemoryStream.Create;
    try
      MS.Position := 0;
      Rich.Lines.SaveToStream(MS);
      MS.Position := 0;
      SL.LoadFromStream(MS);
    finally
      MS.Free;
    end;
  finally
    Rich.Free;
  end;
end;


//----------------------------------------
// m[hm[hԍT
//----------------------------------------
function TMainForm.FindNodeFromNodeNo(No: Integer; out Node: PVirtualNode): Boolean;
var
  Data: PNodeData;
begin
  Result := False;

  Node := TreeView.RootNode.FirstChild;
  while Assigned(Node) do
  begin
    Data := TreeForm.NodeData(Node);
    if Data.NodeNo  = No then
    begin
      Result := True;
      Exit;
    end;
    Node := TreeView.GetNext(Node);
  end;
end;


//----------------------------------------
// irQ[gNA
//----------------------------------------
procedure TMainForm.ClearNavigator;
begin
  SubmenuItemNaviPrev.Clear;
  SubmenuItemNaviNext.Clear;
end;


//----------------------------------------
// irQ[gɒǉ
//----------------------------------------
procedure TMainForm.AddNavigator(Node: PVirtualNode);
var
  Item: TTBCustomItem;
begin
  if FInNavigate then Exit;

  RefreshNaviagator;

  SubmenuItemNaviNext.Clear;

  if SubmenuItemNaviPrev.Count = 16 then
  begin
    SubmenuItemNaviPrev.Delete(15);
  end;
  Item := TTBCustomItem.Create(Self);
  Item.Tag := TreeForm.NodeData(Node).NodeNo;
  Item.OnClick := NaviPrevClick;
  SubmenuItemNaviPrev.Insert(0, Item);
end;


//----------------------------------------
// irQ[gXV
//----------------------------------------
procedure TMainForm.RefreshNaviagator;
var
  I: Integer;
  Node: PVirtualNode;
begin
  // ȂĂ܂m[h΁A폜
  for I := SubmenuItemNaviPrev.Count -1 downto 0 do
  begin
    if not FindNodeFromNodeNo(SubmenuItemNaviPrev.Items[I].Tag, Node) then
    begin
      SubmenuItemNaviPrev.Delete(I);
    end;
  end;

  for I := SubmenuItemNaviNext.Count -1 downto 0 do
  begin
    if not FindNodeFromNodeNo(SubmenuItemNaviNext.Items[I].Tag, Node) then
    begin
      SubmenuItemNaviNext.Delete(I);
    end;
  end;
end;


//----------------------------------------
// ߂郁j[NbN
//----------------------------------------
procedure TMainForm.NaviPrevClick(Sender: TObject);
var
  NodeNo: Integer;
  OldNode: PVirtualNode;
  I: Integer;
  Idx: Integer;
  Node: PVirtualNode;
  Item: TTBCustomItem;
begin
  FInNavigate := True;
  try
    OldNode := TreeView.FocusedNode;

    NodeNo := (Sender as TTBCustomItem).Tag;
    Idx := SubmenuItemNaviPrev.IndexOf(Sender as TTBCustomItem);
    for I := 0 to Idx do
    begin
      // uiށv̕ɒǉ
      Item := TTBCustomItem.Create(Self);
      Item.Tag := SubmenuItemNaviPrev.Items[0].Tag;
      Item.OnClick := NaviNextClick;
      SubmenuItemNaviNext.Insert(0, Item);
      // u߂v폜
      SubmenuItemNaviPrev.Delete(0);
    end;
    SubmenuItemNaviNext.Delete(0);

    if FindNodeFromNodeNo(NodeNo, Node) then
    begin
      TreeView.ClearSelection;
      TreeView.FocusedNode := Node;
      TreeView.Selected[Node] := True;
    end;

    Item := TTBCustomItem.Create(Self);
    Item.Tag := TreeForm.NodeData(OldNode).NodeNo;
    Item.OnClick := NaviNextClick;
    SubmenuItemNaviNext.Add(Item);
  finally
    FInNavigate := False;
  end;
end;


//----------------------------------------
// iރj[NbN
//----------------------------------------
procedure TMainForm.NaviNextClick(Sender: TObject);
var
  NodeNo: Integer;
  OldNode: PVirtualNode;
  I: Integer;
  Idx: Integer;
  Node: PVirtualNode;
  Item: TTBCustomItem;
begin
  FInNavigate := True;
  try
    OldNode := TreeView.FocusedNode;

    NodeNo := (Sender as TTBCustomItem).Tag;
    Idx := SubmenuItemNaviNext.IndexOf(Sender as TTBCustomItem);
    for I := 0 to Idx do
    begin
      // u߂v̕ɒǉ
      Item := TTBCustomItem.Create(Self);
      Item.Tag := SubmenuItemNaviNext.Items[0].Tag;
      Item.OnClick := NaviPrevClick;
      SubmenuItemNaviPrev.Insert(0, Item);
      // uiށv폜
      SubmenuItemNaviNext.Delete(0);
    end;
    SubmenuItemNaviPrev.Delete(0);

    if FindNodeFromNodeNo(NodeNo, Node) then
    begin
      TreeView.ClearSelection;
      TreeView.FocusedNode := Node;
      TreeView.Selected[Node] := True;
    end;

    Item := TTBCustomItem.Create(Self);
    Item.Tag := TreeForm.NodeData(OldNode).NodeNo;
    Item.OnClick := NaviPrevClick;
    SubmenuItemNaviPrev.Add(Item);
  finally
    FInNavigate := False;
  end;
end;


//----------------------------------------
// 
//----------------------------------------
procedure TMainForm.FindText(StartPos: Integer);
var
  L: Integer;
  FindPos: Integer;
  Node: PVirtualNode;
  Rich: TJvRichEdit;
  MS: TMemoryStream;
  Data: PNodeData;
begin
  // 
  if stBackward in FindDlg.SearchTypes then
  begin
    L := Editor.SelStart;
  end
  else
  begin
    L := Length(Editor.Lines.Text) - Editor.SelStart;
  end;

  // 
  FindPos := Editor.FindText(FindDlg.FindText, StartPos, L, FindDlg.SearchTypes);

  // ꍇA̕I
  if FindPos <> -1 then
  begin
    Editor.SelStart := FindPos;
    Editor.SelLength := Length(WideString(FindDlg.FindText));
  end
  // Ȃꍇ
  else
  begin
    // ŜT̃`FbNAI
    if not FindDlg.CheckBoxDocument.Checked then
    begin
      MessageDlg('͌܂łB', mtConfirmation, [mbOK], 0);
      Exit;
    end;

    // ŜTꍇAɌ
    Node := TreeView.FocusedNode;
    while True do
    begin
      if stBackward in FindDlg.SearchTypes then
      begin
        Node := TreeView.GetPrevious(Node);
      end
      else
      begin
        Node := TreeView.GetNext(Node);
      end;
      if not Assigned(Node) then
      begin
        MessageDlg('͌܂łB', mtConfirmation, [mbOK], 0);
        Exit;
      end;

      Rich := TJvRichEdit.Create(nil);
      try
        Rich.Visible := False;
        Rich.Parent := Self;
        Rich.StreamFormat := sfRichText;
        Rich.WordWrap := False;
        MS := TMemoryStream.Create;
        try
          MS.Position := 0;
          Data := TreeForm.NodeData(Node);
          Data.Strings.SaveToStream(MS);
          MS.Position := 0;
          Rich.Lines.LoadFromStream(MS);
        finally
          MS.Free;
        end;

        if stBackward in FindDlg.SearchTypes then
        begin
          StartPos := Length(Rich.Text);
        end
        else
        begin
          StartPos := 0;
        end;

        FindPos := Rich.FindText(FindDlg.FindText, StartPos, Length(Rich.Text), FindDlg.SearchTypes);
        if FindPos <> -1 then
        begin
          TreeView.FocusedNode := Node;
          TreeView.ClearSelection;
          TreeView.Selected[Node] := True;
          Editor.SelStart := FindPos;
          Editor.SelLength := Length(WideString(FindDlg.FindText));
          Exit;
        end;

      finally
        Rich.Free;
      end;
    end;
  end;
end;


//----------------------------------------
// tH[̏
//----------------------------------------
procedure TMainForm.FormCreate(Sender: TObject);
var
  C: HCURSOR;
begin
  C := LoadCursor(0, IDC_HAND);
  if C <> 0 then Screen.Cursors[crHandPoint] := C;

  EditTitle.DoubleBuffered := True;
  FStream := TMemoryStream.Create;

  // SusievOC̃tH_w
  SPIs.Search(ExtractFilePath(Application.ExeName) + 'plugin\*.spi');
end;


//----------------------------------------
// tH[\
//----------------------------------------
procedure TMainForm.FormShow(Sender: TObject);
var
  Ini: TIniFile;
  S: String;
begin
  GlobalModule.IniStorage.Path := 'Form';

  // [̐ݒǂݍ
  EditorForm.Ruler.LeftMargin := GlobalModule.IniStorage.ReadFloat('LeftMargin', 0.5);
  EditorForm.Ruler.RightMargin := GlobalModule.IniStorage.ReadFloat('RightMargin', 7);

  // ^CgplA[[AXe[^Xo[̐ݒǂݍ
  TitlePanel.Visible := GlobalModule.IniStorage.ReadBoolean('TitlePanel', True);
  EditorForm.Ruler.Visible := GlobalModule.IniStorage.ReadBoolean('Ruler', True);
  StatusBar.Visible := GlobalModule.IniStorage.ReadBoolean('StatusBar', True);

  GlobalModule.IniStorage.Path := 'General';
  // IME[hǂݍ
  if True = GlobalModule.IniStorage.ReadBoolean('ImeMode', False) then
  begin
    SetImeMode(Self.Handle, imHira);
  end;

  // MRUǂݍ
  Ini := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'NanaTreeMRU.ini');
  try
    MRUList.LoadFromIni(Ini, 'MRU');
  finally
    Ini.Free;
  end;

  // tHgX^Cǂݍ
  LoadFontStyles;

  // L[tǂݍ
  LoadKeyBind;

  // oO΍
  EditorForm.Hide;

  if FileExists(ExtractFilePath(Application.ExeName) + 'NanaTreeDocking.ini') then
  begin
    // hbLOۑt@C畜
    LoadDockTreeFromFile(ExtractFilePath(Application.ExeName) + 'NanaTreeDocking.ini');
  end
  else
  begin
    // ݒɈʒuݒ肪Ȃꍇ́Azu𐶐
    TreeForm.Show;
    TreeForm.ManualDock(JvDockServer.LeftDockPanel, nil, alLeft);
    JvDockServer.LeftDockPanel.Width := Trunc(Self.Width * 0.3);
  end;

  // oO΍
  JvEmbeddedFormPanel.FormLink := nil;
  JvEmbeddedFormPanel.FormLink := EditorForm.JvEmbeddedFormLink;
  JvEmbeddedFormPanel.Update;

  TreeForm.JvDockClient.LRDockWidth := 160;
  TreeForm.JvDockClient.TBDockHeight := 120;

  // c[o[ԓǂݍ
  if FileExists(ExtractFilePath(Application.ExeName) + 'NanaTreeToolbar.ini') then
  begin
    TBIniLoadPositions(Self, ExtractFilePath(Application.ExeName) + 'NanaTreeToolbar.ini', 'Toolbar');
  end;

  // ݒǂݍ
  LoadSetting;

  TreeForm.Modified := False;
  Editor.Modified := False;
  FModified := False;

  Editor.SetFocus;

  // Ñp[^Ńt@CnĂꍇÃt@CJ
  if ParamCount > 0 then
  begin
    if FileExists(ParamStr(1)) then
    begin
      OpenFile(ParamStr(1));
      Exit;
    end;
  end;

  // NɁAOJĂt@CJݒɂȂĂꍇAJ
  GlobalModule.IniStorage.Path := 'General';
  if True = GlobalModule.IniStorage.ReadBoolean('AutoOpen', False) then
  begin
    if MRUList.Items.Count > 0 then
    begin
      S := MRUList.Items[0];
      if FileExists(S) then
      begin
        OpenFile(S);
        Exit;
      end;
    end;
  end;

  // VKŋN
  CreateNewDocument;
end;


//----------------------------------------
// tH[j
//----------------------------------------
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  I: Integer;
  Ini: TIniFile;
begin
  QuerySaveDocument;

  // tHgJ
  for I := Low(FUserFonts) to High(FUserFonts) do
  begin
    if Assigned(FUserFonts[I]) then
    begin
      FreeAndNil(FUserFonts[I]);
    end;
  end;

  GlobalModule.IniStorage.Path := 'Form';

  // [̐ݒ菑
  GlobalModule.IniStorage.WriteFloat('LeftMargin', EditorForm.Ruler.LeftMargin);
  GlobalModule.IniStorage.WriteFloat('RightMargin', EditorForm.Ruler.RightMargin);

  // ^CgplA[[AXe[^Xo[̐ݒ菑
  GlobalModule.IniStorage.WriteBoolean('TitlePanel', TitlePanel.Visible);
  GlobalModule.IniStorage.WriteBoolean('Ruler', EditorForm.Ruler.Visible);
  GlobalModule.IniStorage.WriteBoolean('StatusBar', StatusBar.Visible);


  // MRU
  Ini := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'NanaTreeMRU.ini');
  try
    MRUList.SaveToIni(Ini, 'MRU');
  finally
    Ini.Free;
  end;

  // hbLOԏ
  SaveDockTreeToFile(ExtractFilePath(Application.ExeName) + 'NanaTreeDocking.ini');

  // c[o[ԏ
  TBIniSavePositions(Self, ExtractFilePath(Application.ExeName) + 'NanaTreeToolbar.ini', 'Toolbar');

end;


//----------------------------------------
// VK쐬
//----------------------------------------
procedure TMainForm.ActionNewExecute(Sender: TObject);
begin
  QuerySaveDocument;
  FStream.Clear;
  CreateNewDocument;

  TreeForm.Modified := False;
  EditorForm.Editor.Modified := False;
  FModified := False;
end;


//----------------------------------------
// J
//----------------------------------------
procedure TMainForm.ActionOpenExecute(Sender: TObject);
begin
  if not OpenDialog.Execute then Exit;

  OpenFile(OpenDialog.FileName);
end;


//----------------------------------------
// ŋߎgt@CJ
//----------------------------------------
procedure TMainForm.MRUListClick(Sender: TObject; const Filename: String);
begin
  OpenFile(Filename);
end;


//----------------------------------------
// ۑ
//----------------------------------------
procedure TMainForm.ActionSaveExecute(Sender: TObject);
begin
  if (FFileName = '') or
     ((ExtractFileExt(FFileName) <> '.nnz') and
      (ExtractFileExt(FFileName) <> '.nna')) then
  begin
    ActionSaveAsExecute(Sender);
  end
  else
  begin
    SaveNanaFile(FFileName);

    TreeForm.Modified := False;
    Editor.Modified := False;
    FModified := False;
  end;
end;

procedure TMainForm.ActionSaveUpdate(Sender: TObject);
begin
  ActionSave.Enabled := IsModified;
end;


//----------------------------------------
// Oĕۑ
//----------------------------------------
procedure TMainForm.ActionSaveAsExecute(Sender: TObject);
begin
  // ftHg̃t@Cݒ
  // Ver.105 kNanat@CΉ 
  if (FFileName = '') or
     ((ExtractFileExt(FFileName) <> '.nna') and
      (ExtractFileExt(FFileName) <> '.nnz')) then
  begin
    SaveDialog.FileName := TreeView.Text[TreeView.GetFirst, -1];
    SaveDialog.FilterIndex := 1;
  end
  else
  begin
    SaveDialog.FileName := FFileName;
    if ExtractFileExt(FFileName) = '.nna' then
    begin
      SaveDialog.FilterIndex := 1;
    end
    else
    begin
      SaveDialog.FilterIndex := 2;
    end;
  end;
  // Ver.105 kNanat@CΉ ܂

  // ۑ
  if SaveDialog.Execute then
  begin
    SaveNanaFile(SaveDialog.FileName);

    FFileName := SaveDialog.FileName;
    DispFilePath;
    MRUList.Add(SaveDialog.FileName);
    TreeForm.Modified := False;
    Editor.Modified := False;
    FModified := False;
  end
  else
  begin
    Abort;
  end;
end;


//----------------------------------------
// y[WGNX|[g
//----------------------------------------
procedure TMainForm.ActionExportPageExecute(Sender: TObject);
begin
  if ExportPageDialog.Execute then
  begin
    SaveToTree(TreeView, TreeView.FocusedNode);

    case ExportPageDialog.FilterIndex of
      1: ExportPageTxt(ExportPageDialog.FileName);  // eLXg
      2: ExportPageRTF(ExportPageDialog.FileName);  // b`eLXg
      3: ExportPageHTML(ExportPageDialog.FileName); // HTML
    end;

  end;
end;

procedure TMainForm.ExportPageDialogTypeChange(Sender: TObject);
begin
  case ExportPageDialog.FilterIndex of
    1: ExportPageDialog.DefaultExt := 'txt';
    2: ExportPageDialog.DefaultExt := 'rtf';
    3: ExportPageDialog.DefaultExt := 'htm';
  end;
end;


//----------------------------------------
// y[WGNX|[g(eLXg)
//----------------------------------------
procedure TMainForm.ExportPageTxt(const Path: TFileName);
begin
  Screen.Cursor := crHourGlass;
  try
    Editor.StreamFormat := sfPlainText;
    Editor.Lines.SaveToFile(Path);
    Editor.StreamFormat := sfRichText;
  finally
    Screen.Cursor := crDefault;
  end;
end;


//----------------------------------------
// y[WGNX|[g(b`eLXg)
//----------------------------------------
procedure TMainForm.ExportPageRTF(const Path: TFileName);
begin
  Screen.Cursor := crHourGlass;
  try
    Editor.Lines.SaveToFile(Path);
  finally
    Screen.Cursor := crDefault;
  end;
end;


//----------------------------------------
// y[WGNX|[g(HTMLeLXg)
//----------------------------------------
procedure TMainForm.ExportPageHTML(const Path: TFileName);
var
  Rich: TJvRichEdit;
  MS: TMemoryStream;
begin
  Rich := TJvRichEdit.Create(nil);
  Screen.Cursor := crHourGlass;
  try
    Rich.Visible := False;
    Rich.Parent := Self;
    Rich.StreamFormat := sfRichText;
    Rich.WordWrap := False;
    Rich.Font.Assign(Editor.Font);
    Rich.DefAttributes.Assign(Editor.DefAttributes);

    MS := TMemoryStream.Create;
    try
      MS.Position := 0;
      Editor.Lines.SaveToStream(MS);
      MS.Position := 0;
      Rich.Lines.LoadFromStream(MS);
    finally
      MS.Free;
    end;

    RichToHTMLExecute(Rich, TreeView.Text[TreeView.FocusedNode, 0], Path);

  finally
    Screen.Cursor := crDefault;
    Rich.Free;
  end;
end;


//----------------------------------------
// GNX|[g
//----------------------------------------
procedure TMainForm.ActionExportDocExecute(Sender: TObject);
begin
  if ExportDocDialog.Execute then
  begin
    SaveToTree(TreeView, TreeView.FocusedNode);

    case ExportDocDialog.FilterIndex of
      1: ExportDocTxt(ExportDocDialog.FileName);        // eLXg
      2: ExportDocTreeTxt(ExportDocDialog.FileName);    // KweLXg
      3: ExportDocRTF(ExportDocDialog.FileName);        // b`eLXg
      4: ExportDocHTML(ExportDocDialog.FileName);       // HTML
    end;

  end;
end;

procedure TMainForm.ExportDocDialogTypeChange(Sender: TObject);
begin
  case ExportDocDialog.FilterIndex of
    1: ExportDocDialog.DefaultExt := 'txt';
    2: ExportDocDialog.DefaultExt := 'txt';
    3: ExportDocDialog.DefaultExt := 'rtf';
    4: ExportDocDialog.DefaultExt := 'htm';
  end;
end;


//----------------------------------------
// GNX|[g(eLXg)
//----------------------------------------
procedure TMainForm.ExportDocTxt(const Path: TFileName);
var
  SL: TStringList;
begin
  SaveToTree(TreeView, TreeView.FocusedNode);

  SL := TStringList.Create;
  Screen.Cursor := crHourGlass;
  try
    CreateDocText(SL);
    SL.SaveToFile(Path);
  finally
    Screen.Cursor := crDefault;
    SL.Free;
  end;
end;


//----------------------------------------
// GNX|[g(KweLXg)
//----------------------------------------
procedure TMainForm.ExportDocTreeTxt(const Path: TFileName);
var
  Node: PVirtualNode;
  Rich: TJvRichEdit;

  // 葱(ۑpeLXg쐬)
  procedure CreateText(Tier: Integer; SL: TStrings; Node: PVirtualNode);
  var
    Data: PNodeData;
    ChildNode: PVirtualNode;
  begin
    while Assigned(Node) do
    begin
      Data := TreeForm.NodeData(Node);

      // c[̃LvVKwoƂĒǉ
      SL.Add(DupeString('.', Tier) + Data.Caption);

      // {ǉ
      SL.Add(Copy(Data.Strings.Text, 1, Length(Data.Strings.Text) -2));

      ChildNode := Node.FirstChild;
      if Assigned(ChildNode) then
      begin
        Tier := Tier + 1;
        CreateText(Tier, SL, ChildNode);   // ċA
        Tier := Tier - 1;
      end;
      Node := Node.NextSibling;
    end;
  end;

begin
  SaveToTree(TreeView, TreeView.FocusedNode);

  Rich := TJvRichEdit.Create(nil);
  Screen.Cursor := crHourGlass;
  try
    Rich.Visible := False;
    Rich.Parent := Self;
    Rich.StreamFormat := sfPlainText;

    Node := TreeView.RootNode.FirstChild;
    CreateText(1, Rich.Lines, Node);
    Rich.Lines.SaveToFile(Path);
  finally
    Screen.Cursor := crDefault;
    Rich.Free;
  end;
end;


//----------------------------------------
// GNX|[g(b`eLXg)
//----------------------------------------
procedure TMainForm.ExportDocRTF(const Path: TFileName);
var
  SL: TStringList;
begin
  SaveToTree(TreeView, TreeView.FocusedNode);

  SL := TStringList.Create;
  Screen.Cursor := crHourGlass;
  try
    CreateDocRichText(SL);
    SL.SaveToFile(Path);
  finally
    Screen.Cursor := crDefault;
    SL.Free;
  end;
end;


//----------------------------------------
// GNX|[g(HTMLeLXg)
//----------------------------------------
procedure TMainForm.ExportDocHTML(const Path: TFileName);

  //----------------------------------------
  // 葱(t[HTMLt@C쐬)
  //----------------------------------------
  procedure CreateFrame(const DirPath: TFileName);
  var
    Template: TStringList;
    Title: String;
    S: String;
  begin
    Template := TStringList.Create;
    try
      Template.LoadFromFile(ExtractFilePath(Application.ExeName) + 'tmpFrame.htm');
      Title := ExtractFileDir(DirPath);
      S := Format(Template.Text, [Title, './menu.htm', Format('./%.5d.htm',[1])]);
      Template.Text := S;
      Template.SaveToFile(DirPath + '\index.htm');
    finally
      Template.Free;
    end;
  end;

  //----------------------------------------
  // 葱(j[HTMLt@C쐬)
  //----------------------------------------
  procedure CreateMenu(const DirPath: TFileName);

    // 葱
    procedure CreateMenu(SL: TStrings; Node: PVirtualNode; var DocNo: Integer);
    var
      Data: PNodeData;
      ChildNode: PVirtualNode;
      I: Integer;
      Title: String;
    begin
      while Assigned(Node) do
      begin
        if Node.PrevSibling = nil then SL.Add('<ul>');

        Data := TreeForm.NodeData(Node);

        // u&vu"vu<vȂǂ̕ϊKv̂镶ϊ
        Title := Data.Caption;
        for I := Low(ReplaceCharArray) to High(ReplaceCharArray) do
        begin
          Title := StringReplace(
            Title,
            ReplaceCharArray[I].Before,
            ReplaceCharArray[I].After,
            [rfReplaceAll]);
        end;

        SL.Add(Format('<li><a href="./%.5d.htm" target="content">%s</a></li>',
          [DocNo, Title]));

        DocNo := DocNo + 1;

        ChildNode := Node.FirstChild;
        if Assigned(ChildNode) then
        begin
          SL.Add('<li>');
          CreateMenu(SL, ChildNode, DocNo);  // ċA
          SL.Add('</li>');
        end;
        Node := Node.NextSibling;
      end;
      SL.Add('</ul>');
    end;

  var
    Template: TStringList;
    SL: TStringList;
    DocNo: Integer;
    Node: PVirtualNode;
    S: String;
  begin
    Template := TStringList.Create;
    SL := TStringList.Create;
    try
      Template.LoadFromFile(ExtractFilePath(Application.ExeName) + 'tmpMenu.htm');

      Node := TreeView.RootNode.FirstChild;
      DocNo := 1;
      CreateMenu(SL, Node, DocNo);
      S := Format(Template.Text, [SL.Text]);
      SL.Text := S;
      SL.SaveToFile(DirPath + '\menu.htm');
    finally
      SL.Free;
      Template.Free;
    end;
  end;

  //----------------------------------------
  // 葱(ey[W쐬)
  //----------------------------------------
  procedure CreateNodes(DirPath: TFileName; Node: PVirtualNode; var DocNo: Integer);
  var
    Data: PNodeData;
    ChildNode: PVirtualNode;
    Rich: TJvRichEdit;
    MS: TMemoryStream;
  begin
    while Assigned(Node) do
    begin
      Data := TreeForm.NodeData(Node);

      Rich := TJvRichEdit.Create(nil);
      try
        Rich.Visible := False;
        Rich.Parent := Self;
        Rich.StreamFormat := sfRichText;
        Rich.WordWrap := False;
        Rich.Font.Assign(Editor.Font);
        Rich.DefAttributes.Assign(Editor.DefAttributes);

        MS := TMemoryStream.Create;
        try
          MS.Position := 0;
          Data.Strings.SaveToStream(MS);
          MS.Position := 0;
          Rich.Lines.LoadFromStream(MS);
        finally
          MS.Free;
        end;

        RichToHTMLExecute(Rich, Data.Caption, Format('%s%.5d.htm', [DirPath + '\', DocNo]));
        DocNo := DocNo + 1;

      finally
        Rich.Free;
      end;

      ChildNode := Node.FirstChild;
      if Assigned(ChildNode) then
      begin
        CreateNodes(DirPath, ChildNode, DocNo);   // ċA
      end;
      Node := Node.NextSibling;
    end;
  end;

var
  DirPath: String;
  DocNo: Integer;
begin
  SaveToTree(TreeView, TreeView.FocusedNode);

  DirPath := ChangeFileExt(Path, '');
  if not DirectoryExists(DirPath) then CreateDir(DirPath);

  Screen.Cursor := crHourGlass;
  try
    Application.ProcessMessages;

    // t[쐬
    CreateFrame(DirPath);

    // j[쐬
    CreateMenu(DirPath);

    // ey[W쐬
    DocNo := 1;
    CreateNodes(Dirpath, TreeView.RootNode.FirstChild, DocNo);
  finally
    Screen.Cursor := crDefault;
  end;
end;


//----------------------------------------
// y[W
//----------------------------------------
procedure TMainForm.ActionPagePrintExecute(Sender: TObject);
var
  Dlg: TPrintPreviewForm;
  MS: TMemoryStream;
begin
  Dlg := TPrintPreviewForm.Create(Self);
  try
    Dlg.PreviewEdit.Font.Assign(Editor.Font);
    Dlg.PreviewEdit.DefAttributes.Assign(Editor.DefAttributes);
    MS := TMemoryStream.Create;
    try
      MS.Position := 0;
      Editor.Lines.SaveToStream(MS);
      MS.Position := 0;
      Dlg.PreviewEdit.Lines.LoadFromStream(MS);
      Dlg.SetPreview;
      Dlg.ShowModal;
    finally
      MS.Free;
    end;
  finally
    Dlg.Release;
  end;
end;


//----------------------------------------
// 
//----------------------------------------
procedure TMainForm.ActionDocPrintExecute(Sender: TObject);
var
  Dlg: TPrintPreviewForm;
begin
  Dlg := TPrintPreviewForm.Create(Self);
  try
    Dlg.PreviewEdit.Font.Assign(Editor.Font);
    Dlg.PreviewEdit.DefAttributes.Assign(Editor.DefAttributes);
    CreateDocRichText(Dlg.PreviewEdit.Lines);
    Dlg.SetPreview;
    Dlg.ShowModal;
  finally
    Dlg.Release;
  end;
end;


//----------------------------------------
// I
//----------------------------------------
procedure TMainForm.ActionExitExecute(Sender: TObject);
begin
  Close;
end;


//----------------------------------------
// t@Cm[hǉ
//----------------------------------------
procedure TMainForm.ActionAddFromFileExecute(Sender: TObject);
var
  I: Integer;
begin
  OpenDialog.Options := OpenDialog.Options + [ofAllowMultiSelect];
  try
    if OpenDialog.Execute then
    begin
      for I := 0 to OpenDialog.Files.Count -1 do
      begin
        TreeForm.AddTreeFromFile(OpenDialog.Files[I], TreeView.FocusedNode, amAddChildLast);
      end;
    end;
  finally
  OpenDialog.Options := OpenDialog.Options - [ofAllowMultiSelect];
  end;
end;


//----------------------------------------
// Rs[
//----------------------------------------
procedure TMainForm.ActionCopyExecute(Sender: TObject);
var
  C: TWinControl;
begin
  C := Self.ActiveControl;
  if not Assigned(C) then Exit;

  // ^CgGfBbgɃtH[JXꍇ
  if C is TJvComboEdit then
  begin
    TJvComboEdit(C).CopyToClipboard;
    Exit;
  end;
  // GfB^ɃtH[JXꍇ
  if C is TNanaRichEdit then
  begin
    EditorForm.ActionEditCopyExecute(Sender);
    Exit;
  end;
  // c[ɃtH[JXꍇ
  if C is TVirtualStringTree then
  begin
    TreeForm.ActionCopyExecute(Sender);
    Exit;
  end;
end;

procedure TMainForm.ActionCopyUpdate(Sender: TObject);
var
  C: TWinControl;
begin
  C := Self.ActiveControl;
  if not Assigned(C) then Exit;

  // ^CgGfBbgɃtH[JXꍇ
  if C is TJvComboEdit then
  begin
    ActionCopy.Enabled := (TJvComboEdit(C).SelLength > 0);
    Exit;
  end;
  // GfB^ɃtH[JXꍇ
  if C is TNanaRichEdit then
  begin
    EditorForm.ActionEditCopyUpdate(Sender);
    ActionCopy.Enabled := EditorForm.ActionEditCopy.Enabled;
    Exit;
  end;
  // c[ɃtH[JXꍇ
  if C is TVirtualStringTree then
  begin
    TreeForm.ActionCopyUpdate(Sender);
    ActionCopy.Enabled := TreeForm.ActionCopy.Enabled;
    Exit;
  end;
end;


//----------------------------------------
// ؂
//----------------------------------------
procedure TMainForm.ActionCutExecute(Sender: TObject);
var
  C: TWinControl;
begin
  C := Self.ActiveControl;
  if not Assigned(C) then Exit;

  // ^CgGfBbgɃtH[JXꍇ
  if C is TJvComboEdit then
  begin
    TJvComboEdit(C).CutToClipboard;
    Exit;
  end;
  // GfB^ɃtH[JXꍇ
  if C is TNanaRichEdit then
  begin
    EditorForm.ActionEditCutExecute(Sender);
    Exit;
  end;
  // c[ɃtH[JXꍇ
  if C is TVirtualStringTree then
  begin
    TreeForm.ActionCutExecute(Sender);
    Exit;
  end;
end;

procedure TMainForm.ActionCutUpdate(Sender: TObject);
var
  C: TWinControl;
begin
  C := Self.ActiveControl;
  if not Assigned(C) then Exit;

  // ^CgGfBbgɃtH[JXꍇ
  if C is TJvComboEdit then
  begin
    ActionCut.Enabled := (TJvComboEdit(C).SelLength > 0);
    Exit;
  end;
  // GfB^ɃtH[JXꍇ
  if C is TNanaRichEdit then
  begin
    EditorForm.ActionEditCutUpdate(Sender);
    ActionCut.Enabled := EditorForm.ActionEditCut.Enabled;
    Exit;
  end;
  // c[ɃtH[JXꍇ
  if C is TVirtualStringTree then
  begin
    TreeForm.ActionCutUpdate(Sender);
    ActionCut.Enabled := TreeForm.ActionCut.Enabled;
    Exit;
  end;
end;


//----------------------------------------
// \t
//----------------------------------------
procedure TMainForm.ActionPasteExecute(Sender: TObject);
var
  C: TWinControl;
begin
  C := Self.ActiveControl;
  if not Assigned(C) then Exit;

  // ^CgGfBbgɃtH[JXꍇ
  if C is TJvComboEdit then
  begin
    TJvComboEdit(C).PasteFromClipboard;
    Exit;
  end;
  // GfB^ɃtH[JXꍇ
  if C is TNanaRichEdit then
  begin
    EditorForm.ActionEditPasteExecute(Sender);
    Exit;
  end;
  // c[ɃtH[JXꍇ
  if C is TVirtualStringTree then
  begin
    TreeForm.ActionPasteExecute(Sender);
    Exit;
  end;
end;

procedure TMainForm.ActionPasteUpdate(Sender: TObject);
var
  C: TWinControl;
begin
  C := Self.ActiveControl;
  if not Assigned(C) then Exit;

  // ^CgGfBbgɃtH[JXꍇ
  if C is TJvComboEdit then
  begin
    EditorForm.ActionEditPaste.Enabled := Clipboard.HasFormat(CF_TEXT);
    Exit;
  end;
  // GfB^ɃtH[JXꍇ
  if C is TNanaRichEdit then
  begin
    EditorForm.ActionEditPasteUpdate(Sender);
    ActionPaste.Enabled := EditorForm.ActionEditPaste.Enabled;
    Exit;
  end;
  // c[ɃtH[JXꍇ
  if C is TVirtualStringTree then
  begin
    TreeForm.ActionPasteUpdate(Sender);
    ActionPaste.Enabled := TreeForm.ActionPaste.Enabled;
    Exit;
  end;
end;


//----------------------------------------
// `Iē\t
//----------------------------------------
procedure TMainForm.ActionFormatPasteExecute(Sender: TObject);
begin
  EditorForm.ActionEditFormatPasteExecute(Sender);
end;

procedure TMainForm.ActionFormatPasteUpdate(Sender: TObject);
var
  C: TWinControl;
begin
  C := Self.ActiveControl;
  if not Assigned(C) then Exit;

  if C is TNanaRichEdit then
  begin
    EditorForm.ActionEditFormatPasteUpdate(Sender);
    ActionFormatPaste.Enabled := EditorForm.ActionEditFormatPaste.Enabled;
    Exit;
  end;
  ActionFormatPaste.Enabled := False;
end;


//----------------------------------------
// SđI
//----------------------------------------
procedure TMainForm.ActionSelectAllExecute(Sender: TObject);
var
  C: TWinControl;
begin
  C := Self.ActiveControl;
  if not Assigned(C) then Exit;

  // GfB^ɃtH[JXꍇ
  if C is TNanaRichEdit then
  begin
    EditorForm.ActionEditSelectAllExecute(Sender);
    Exit;
  end;
  // c[ɃtH[JXꍇ
  if C is TVirtualStringTree then
  begin
    TreeView.SelectAll(False);
    Exit;
  end;
end;

procedure TMainForm.ActionSelectAllUpdate(Sender: TObject);
var
  C: TWinControl;
begin
  C := Self.ActiveControl;
  if not Assigned(C) then Exit;

  // GfB^ɃtH[JXꍇ
  if C is TNanaRichEdit then
  begin
    ActionSelectAll.Enabled := True;
    Exit;
  end;
  // c[ɃtH[JXꍇ
  if C is TVirtualStringTree then
  begin
    ActionSelectAll.Enabled := True;
    Exit;
  end;
  ActionSelectAll.Enabled := False;
end;


//----------------------------------------
// Rg[\ؑ
//----------------------------------------
procedure TMainForm.ActionShowMainToolBarExecute(Sender: TObject);
begin
  MainToolBar.Visible := ActionShowMainToolBar.Checked;
end;

procedure TMainForm.ActionShowMainToolBarUpdate(Sender: TObject);
begin
  ActionShowMainToolBar.Checked := MainToolbar.Visible;
end;

procedure TMainForm.ActionShowFormatToolBarExecute(Sender: TObject);
begin
  FormatToolbar.Visible := ActionShowFormatToolBar.Checked;
end;

procedure TMainForm.ActionShowFormatToolBarUpdate(Sender: TObject);
begin
  ActionShowFormatToolBar.Checked := FormatToolbar.Visible;
end;

procedure TMainForm.ActionShowTreeToolBarExecute(Sender: TObject);
begin
  TreeToolbar.Visible := ActionShowTreeToolBar.Checked;
end;

procedure TMainForm.ActionShowTreeToolBarUpdate(Sender: TObject);
begin
  ActionShowTreeToolBar.Checked := TreeToolbar.Visible;
end;

procedure TMainForm.ActionShowTitleBarExecute(Sender: TObject);
begin
  TitlePanel.Visible := ActionShowTitleBar.Checked;
end;

procedure TMainForm.ActionShowTitleBarUpdate(Sender: TObject);
begin
  ActionShowTitleBar.Checked := TitlePanel.Visible;
end;

procedure TMainForm.ActionShowRulerExecute(Sender: TObject);
begin
  EditorForm.Ruler.Visible := ActionShowRuler.Checked;
  EditorForm.ActionSetEditRectExecute(Sender);
end;

procedure TMainForm.ActionShowRulerUpdate(Sender: TObject);
begin
  ActionShowRuler.Checked := EditorForm.Ruler.Visible;
end;

procedure TMainForm.ActionShowStatusBarExecute(Sender: TObject);
begin
  StatusBar.Visible := ActionShowStatusBar.Checked;
end;

procedure TMainForm.ActionShowStatusBarUpdate(Sender: TObject);
begin
  ActionShowStatusBar.Checked := StatusBar.Visible;
end;


//----------------------------------------
// o[W
//----------------------------------------
procedure TMainForm.ActionAboutExecute(Sender: TObject);
var
  Dlg: TAboutDlg;
begin
  Dlg := TAboutDlg.Create(Self);
  try
    Dlg.ShowModal;
  finally
    Dlg.Release;
  end;
end;


//----------------------------------------
// J[{^`
//----------------------------------------
procedure TMainForm.SubmenuItemColorDrawImage(Item: TTBCustomItem;
  Viewer: TTBItemViewer; Canvas: TCanvas; ImageRect: TRect;
  ImageOffset: TPoint; StateFlags: Integer);
var
  DC: HDC;
  Color: TColor;
begin
  DC := Canvas.Handle;
  if not Boolean(StateFlags and ISF_DISABLED) then
  begin
    Color := ColorPalette.Color;
    OffsetRect(ImageRect, ImageOffset.X, ImageOffset.Y);
    ImageRect.Top := ImageRect.Bottom - 4;
    if Color <> clNone then
    begin
      Canvas.Brush.Color := Color;
      Canvas.FillRect(ImageRect);
    end
    else
    begin
      FrameRectEx(DC, ImageRect, clBtnShadow, True);
      DitherRect(DC, ImageRect, clBtnFace, clBtnShadow);
    end;
  end;
end;


//----------------------------------------
// tHgύX
//----------------------------------------
procedure TMainForm.FontComboBoxChange(Sender: TObject);
begin
  Editor.SelAttributes.Name := FontComboBox.FontName;
end;


//----------------------------------------
// tHgTCYύX
//----------------------------------------
procedure TMainForm.FontSizeComboBoxChange(Sender: TObject);
begin
  try
    Editor.SelAttributes.Size := StrToInt(FontSizeComboBox.Text);
  except
  end;
end;


//----------------------------------------
// tHgFύX
//----------------------------------------
procedure TMainForm.SubmenuItemColorClick(Sender: TObject);
begin
  Editor.SelAttributes.Color := ColorPalette.Color;
end;


//----------------------------------------
// qg\
//----------------------------------------
procedure TMainForm.ApplicationEventsHint(Sender: TObject);
begin
  StatusBar.Panels[0].Text := Application.Hint;
end;


//----------------------------------------
// ACh
//----------------------------------------
procedure TMainForm.ApplicationEventsIdle(Sender: TObject;
  var Done: Boolean);
const
  PositionInfo = 'm[hʒuF%4d / %4d';
begin
  ActionNaviPrev.Enabled := SubmenuItemNaviPrev.Count > 0;
  ActionNaviNext.Enabled := SubmenuItemNaviNext.Count > 0;

  StatusBar.Panels[1].Text := Format(PositionInfo, [
    TreeView.AbsoluteIndex(TreeView.FocusedNode) + 1,
    TreeView.TotalCount]);
end;


//----------------------------------------
// ^CgeLXgύX
//----------------------------------------
procedure TMainForm.EditTitleChange(Sender: TObject);
begin
  TreeView.Text[TreeView.FocusedNode, 0] := EditTitle.Text;
  TreeForm.Modified := True;
end;


//----------------------------------------
// m[h
//----------------------------------------
procedure TMainForm.ActionTreeMergeNodeExecute(Sender: TObject);
var
  Nodes: TNodeArray;
  Node: PVirtualNode;
  DstRich: TJvRichEdit;
  SrcRich: TJvRichEdit;
  Data: PNodeData;
  MS: TMemoryStream;
  I: Integer;
begin
  Nodes := nil;

  GlobalModule.IniStorage.Path := 'Tree';
  if True = GlobalModule.IniStorage.ReadBoolean('Warning', True) then
  begin
    if mrYes <> MessageDlg(
      'm[h܂B̑͌ɖ߂܂B'#13#10'낵łH',
      mtConfirmation, [mbYes, mbNo], 0) then Exit;
  end;

  SaveToTree(TreeView, TreeView.FocusedNode);

  Nodes := TreeView.GetSortedSelection(False);

  // m[h̃y[W擾
  DstRich := TJvRichEdit.Create(nil);
  try
    DstRich.Visible := False;
    DstRich.Parent := Self;
    DstRich.StreamFormat := sfRichText;
    DstRich.WordWrap := False;
    DstRich.Font.Assign(Editor.Font);
    DstRich.DefAttributes.Assign(Editor.DefAttributes);

    MS := TMemoryStream.Create;
    try
      MS.Position := 0;
      Node := Nodes[0];
      Data := TreeForm.NodeData(Node);
      Data.Strings.SaveToStream(MS);
      MS.Position := 0;
      DstRich.Lines.LoadFromStream(MS);
      DstRich.SelStart := Length(DstRich.Text);
    finally
      MS.Free;
    end;

    // m[h̃y[WĂ
    for I := 1 to High(Nodes) do
    begin
      SrcRich := TJvRichEdit.Create(nil);
      try
        SrcRich.Visible := False;
        SrcRich.Parent := Self;
        SrcRich.StreamFormat := sfRichText;
        SrcRich.WordWrap := False;
        SrcRich.Font.Assign(Editor.Font);
        SrcRich.DefAttributes.Assign(Editor.DefAttributes);

        MS := TMemoryStream.Create;
        try
          MS.Position := 0;
          Node := Nodes[I];
          Data := TreeForm.NodeData(Node);
          Data.Strings.SaveToStream(MS);
          MS.Position := 0;
          SrcRich.Lines.LoadFromStream(MS);
        finally
          MS.Free;
        end;

        SrcRich.SelectAll;
        SrcRich.CopyToClipboard;
        DstRich.PasteFromClipboard;

      finally
        SrcRich.Free;
      end;
    end;
    Clipboard.Clear;

    // ʂm[hɊi[
    MS := TMemoryStream.Create;
    try
      MS.Position := 0;
      DstRich.Lines.SaveToStream(MS);
      MS.Position := 0;
      Data := TreeForm.NodeData(Nodes[0]);
      Data.Strings.LoadFromStream(MS);
    finally
      MS.Free;
    end;

    // m[h폜
    for I := 1 to High(Nodes) do
    begin
      if Nodes[I].ChildCount > 0 then
      begin
        TreeView.MoveTo(Nodes[I], Nodes[I], amInsertBefore, True);
      end;
      TreeView.DeleteNode(Nodes[I]);
    end;

    // m[hɃtH[JXꍇAɍXV
    if TreeView.FocusedNode = Nodes[0] then
    begin
      LoadFromTree(TreeView, Nodes[0]);
    end;
    TreeView.FocusedNode := Nodes[0];
    //TreeView.Selected[TreeView.FocusedNode] := True;

  finally
    DstRich.Free;
  end;
  FModified := True;
end;

procedure TMainForm.ActionTreeMergeNodeUpdate(Sender: TObject);
begin
  ActionTreeMergeNode.Enabled := TreeView.SelectedCount >= 2;
end;


//----------------------------------------
// m[h
//----------------------------------------
procedure TMainForm.ActionTreeSplitNodeExecute(Sender: TObject);
var
  S: String;
  Node: PVirtualNode;
  Data: PNodeData;
begin
  GlobalModule.IniStorage.Path := 'Tree';
  if True = GlobalModule.IniStorage.ReadBoolean('Warning', True) then
  begin
    if mrYes <> MessageDlg(
      'm[h𕪊܂B̑͌ɖ߂܂B'#13#10'낵łH',
      mtConfirmation, [mbYes, mbNo], 0) then Exit;
  end;

  Clipboard.Clear;
  S := TreeView.Text[TreeView.FocusedNode, -1];

  Editor.Lines.BeginUpdate;
  try
    Editor.SelLength := Length(Editor.Text) - Editor.SelStart;
    Editor.CutToClipboard;

    TreeForm.ActionAddNodeExecute(Sender);
    Node := TreeView.FocusedNode;
    Data := TreeForm.NodeData(Node);
    Data.Caption := S + '2';
    TreeView.ClearSelection;
    TreeView.FocusedNode := Node;
    TreeView.Selected[Node] := True;

    Editor.PasteFromClipboard;
    Editor.SelStart := 0;
  finally
    Editor.Lines.EndUpdate;
  end;

  Clipboard.Clear;
end;


//----------------------------------------
// ߂
//----------------------------------------
procedure TMainForm.ActionNaviPrevExecute(Sender: TObject);
var
  NodeNo: Integer;
  OldNode: PVirtualNode;
  Node: PVirtualNode;
  Item: TTBCustomItem;
begin
  FInNavigate := True;
  try
    OldNode := TreeView.FocusedNode;

    NodeNo := SubmenuItemNaviPrev.Items[0].Tag;
    if FindNodeFromNodeNo(NodeNo, Node) then
    begin
      TreeView.ClearSelection;
      TreeView.FocusedNode := Node;
      TreeView.Selected[Node] := True;
      SubmenuItemNaviPrev.Delete(0);

      Item := TTBCustomItem.Create(Self);
      Item.Tag := TreeForm.NodeData(OldNode).NodeNo;
      Item.OnClick := NaviNextClick;
      SubmenuItemNaviNext.Insert(0, Item);
    end;
  finally
    FInNavigate := False;
  end;
end;


//----------------------------------------
// i
//----------------------------------------
procedure TMainForm.ActionNaviNextExecute(Sender: TObject);
var
  NodeNo: Integer;
  OldNode: PVirtualNode;
  Node: PVirtualNode;
  Item: TTBCustomItem;
begin
  FInNavigate := True;
  try
    OldNode := TreeView.FocusedNode;

    NodeNo := SubmenuItemNaviNext.Items[0].Tag;
    if FindNodeFromNodeNo(NodeNo, Node) then
    begin
      TreeView.ClearSelection;
      TreeView.FocusedNode := Node;
      TreeView.Selected[Node] := True;
      SubmenuItemNaviNext.Delete(0);

      Item := TTBCustomItem.Create(Self);
      Item.Tag := TreeForm.NodeData(OldNode).NodeNo;
      Item.OnClick := NaviPrevClick;
      SubmenuItemNaviPrev.Insert(0, Item);
    end;
  finally
    FInNavigate := False;
  end;
end;


//----------------------------------------
// ߂/i j[\(\uԂɃm[h̕擾)
//----------------------------------------
procedure TMainForm.SubmenuItemNaviPopup(Sender: TTBCustomItem;
  FromLink: Boolean);
var
  I: Integer;
  Item: TTBCustomItem;
  Node: PVirtualNode;
  Data: PNodeData;
begin
  for I := 0 to Sender.Count -1 do
  begin
    Item := Sender.Items[I];
    if FindNodeFromNodeNo(Item.Tag, Node) then
    begin
      Data := TreeForm.NodeData(Node);
      Item.Caption := Data.Caption + '(&' + IntToHex(I, 1) + ')';
    end;
  end;
end;


//----------------------------------------
// m[h̃Xe[gC[WύX
//----------------------------------------
procedure TMainForm.ActionImageExecute(Sender: TObject);
var
  Node: PVirtualNode;
  Data: PNodeData;
begin
  Node := TreeView.FocusedNode;
  Data := TreeForm.NodeData(Node);
  if Data.StateIndex <> (Sender as TAction).ImageIndex then
  begin
    Data.StateIndex := (Sender as TAction).ImageIndex;
    TreeForm.Modified := True;
    TreeView.RepaintNode(Node);
    StateButton.Action := (Sender as TAction);
  end;
end;


//----------------------------------------
// ݒ_CAO
//----------------------------------------
procedure TMainForm.ActionSettingExecute(Sender: TObject);
var
  Dlg: TSettingDlg;
begin
  Dlg := TSettingDlg.Create(Self);
  try
    if mrOK = Dlg.ShowModal then
    begin
      LoadSetting;
      EditorForm.ActionSetEditRectExecute(Sender);
      UpdateCursorPos;
    end;
  finally
    Dlg.Release;
  end;
end;


//----------------------------------------
// tHgƃtHgTCY͕ύXȂ`FbNON/OFF
//----------------------------------------
procedure TMainForm.ActionFontStyleNoChangeFontExecute(Sender: TObject);
begin
  ActionFontStyleNoChangeFont.Checked := not ActionFontStyleNoChangeFont.Checked;
end;


//----------------------------------------
// I𕔕tHgX^CŕύX
//----------------------------------------
procedure TMainForm.ActionFontStyleExecute(Sender: TObject);
var
  I: Integer;
begin
  I := (Sender as TAction).Tag;

  if ActionFontStyleNoChangeFont.Checked then
  begin
    Editor.SelAttributes.Color := FUserFonts[I].Color;
    Editor.SelAttributes.Style := FUserFonts[I].Style;
  end
  else
  begin
    Editor.SelAttributes.Assign(FUserFonts[I]);
  end;
end;


//----------------------------------------
// tHgX^Cݒ_CAO\
//----------------------------------------
procedure TMainForm.ActionFontStyleSettingExecute(Sender: TObject);
var
  Dlg: TEditFontStyleDlg;
begin
  Dlg := TEditFontStyleDlg.Create(Self);
  try
    if mrOK = Dlg.ShowModal then
    begin
      LoadFontStyles;
    end;
  finally
    Dlg.Release;
  end;
end;


//----------------------------------------
// L[t_CAO
//----------------------------------------
procedure TMainForm.ActionKeySettingExecute(Sender: TObject);
var
  Dlg: TKeyBindDlg;
begin
  Dlg := TKeyBindDlg.Create(Self);
  try
    if mrOk = Dlg.ShowModal then
    begin
      LoadKeyBind;
    end;
  finally
    Dlg.Release;
  end;
end;


//----------------------------------------
// 悭ȂǁAXPX^C̎ȀȂ
// c[{^ւ܂Ȃ
//----------------------------------------
procedure TMainForm.ApplicationEventsMessage(var Msg: tagMSG;
  var Handled: Boolean);
begin
  case Msg.Message of
    WM_USER + $0500: Handled := True;
  end;
end;


//----------------------------------------
// 
//----------------------------------------
procedure TMainForm.ActionFindExecute(Sender: TObject);
begin
  if mrOK = FindDlg.ShowModal then
  begin
    FindText(Editor.SelStart);
  end;
end;


//----------------------------------------
// O
//----------------------------------------
procedure TMainForm.ActionFindPrevExecute(Sender: TObject);
begin
  FindDlg.SearchTypes := FindDlg.SearchTypes + [stBackward];
  FindText(Editor.SelStart);
end;

procedure TMainForm.ActionFindPrevUpdate(Sender: TObject);
begin
  ActionFindPrev.Enabled := FindDlg.FindText <> '';
end;


//----------------------------------------
// 
//----------------------------------------
procedure TMainForm.ActionFindNextExecute(Sender: TObject);
begin
  FindDlg.SearchTypes := FindDlg.SearchTypes - [stBackward];
  FindText(Editor.SelStart + 1);
end;

procedure TMainForm.ActionFindNextUpdate(Sender: TObject);
begin
  ActionFindNext.Enabled := FindDlg.FindText <> '';
end;


//----------------------------------------
// u
//----------------------------------------
procedure TMainForm.ActionFindReplaceExecute(Sender: TObject);
begin
  Editor.ReplaceDialog('', '');
end;



//----------------------------------------
// b`eLXg -> HTMLϊ
// Ver0.81 Am[hN@\ɂ
// b`eLXgƃc[̗ɃANZXKv
// ߁AHTMLϊNX̏MainForm
// Ɉړ
//----------------------------------------

//----------------------------------------
// HTML̋֎~HTMLp̕ɕϊ
//----------------------------------------
function ReplaceSpecialString(S: String): string;
var
  I: Integer;
begin
  for I := Low(ReplaceCharArray) to High(ReplaceCharArray) do
  begin
    if S = ReplaceCharArray[I].Before then
    begin
      Result := ReplaceCharArray[I].After;
      Exit;
    end;
  end;
  Result := S;
end;


//----------------------------------------
// TColorHTMLJ[擾
//----------------------------------------
function GetHTMLColor(const Value: TColor): String;
var
  I: Integer;
  C: TColor;
begin
  for I := Low(ReplaceColorArray) to High(ReplaceColorArray) do
  begin
    if ReplaceColorArray[I].Before = Value then
    begin
      Result := ReplaceColorArray[I].After;
      Exit;
    end;
  end;
  C := ColorToRGB(Value);
  Result := IntToHex(GetRValue(C), 2) + IntToHex(GetGValue(C), 2) + IntToHex(GetBValue(C), 2);
end;


//----------------------------------------
// RichEdit̓eHTMLt@Cɕۑ
//----------------------------------------
procedure TMainForm.RichToHTMLExecute(Edit: TJvRichEdit;
  const Title: String; const FileName: TFileName);
var
  SL: TStringList;
begin
  SL := TStringList.Create;
  try
    RichToHTMLExecuteToStringList(Edit, SL, Title, FileName);
    SL.SaveToFile(FileName);
  finally
    SL.Free;
  end;
end;


//----------------------------------------
// RichEdit̓eHTMLɕϊ
//----------------------------------------

// HTML^O
const
  TagHTMLHeadder =
    '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">' + #13#10 +
    '<html lang="ja">' + #13#10 +
    '<head>' + #13#10 +
    '<meta http-equiv="content-type" content="text/html;charset=Shift_JIS">' + #13#10 +
    '<meta http-equiv="content-style-type" content="text/css">' + #13#10 +
    '<title>%s</title>' + #13#10 +
    '</head>' + #13#10 +
    '<body>' + #13#10;

  TagHTMLFooter = '</body></html>';

  TagBR = '<br>' + #13#10;

  StyleFontFamily = 'font-family: ''%s''; ';
  StyleFontColor = 'color: %s; ';
  StyleFontSize = 'font-size: %spt; ';
  TagSpan = '<span style="';
  TagEndSpan = '</span>';
  TagEndTag = '">';

  TagLeftP = '<p style="text-align: left;">' + #13#10;
  TagCenterP = '<p style="text-align: center;">' + #13#10;
  TagRightP = '<p style="text-align: right;">' + #13#10;
  TagEndP = '</p>' + #13#10;

  TagUL = '<ul>' + #13#10;
  TagEndUL = '</ul>' + #13#10;
  TagOL = '<ol>' + #13#10;
  TagEndOL = '</ol>' + #13#10;
  TagList = '<li>';
  TagEndList = '</li>' + #13#10;

procedure TMainForm.RichToHTMLExecuteToStringList(Edit: TJvRichEdit;
  SL: TStrings; const Title: String; const FileName: TFileName);
var
  AttrCount: Integer;
  CT: Integer;
  I, J, L, CurPos: Integer;
  ImgNo: Integer;
  Alignment: TParaAlignment;
  Numbering: TJvNumbering;
  FontAttr: TFont;
  IsInPara: Boolean;
  IsInLink: Boolean;
  Script: TSubscriptStyle;
  LinkStr: String;
  Node: PVirtualNode;

  // C[W̏o
  procedure CreateImage;
  var
    Pic: TPicture;
    Bmp: TBitmap;
    Jpg: TJpegImage;
    ImgName: string;
  begin
    if stObject in Edit.SelectionType then
    begin
      Edit.CopyToClipboard;

      Pic := TPicture.Create;
      Bmp := TBitmap.Create;
      Jpg := TJPEGImage.Create;
      try
        Pic.Assign(Clipboard);
        Bmp.Width := Pic.Graphic.Width;
        Bmp.Height := Pic.Graphic.Height;
        Bmp.Canvas.Draw(0, 0, Pic.Graphic);
        Jpg.Assign(Bmp);
        ImgName := ExtractFilePath(FileName) + ChangeFileExt(ExtractFileName(FileName), '');
        Jpg.SaveToFile(Format('%s-%.5d.jpg', [ImgName, ImgNo]));
        Clipboard.Clear;
      finally
        Jpg.Free;
        Bmp.Free;
        Pic.Free;
      end;
    end;
  end;

  // tHg
  procedure InitFont;
  begin
    AttrCount := 0;
    FontAttr.Name := 'Dummy';
    FontAttr.Size := DEFAULT_FONT_SIZE;
    FontAttr.Color := DEFAULT_FONT_COLOR;
    FontAttr.Style := [];
    Script := ssNone;
  end;

  // 
  procedure CloseAttr;
  var
    Cnt: Integer;
  begin
    for Cnt := 1 to AttrCount do
    begin
      SL[SL.Count-1] := SL[SL.Count-1] + TagEndSpan;
    end;
    AttrCount := 0;
    InitFont;
  end;

  // <p>^O
  procedure CloseParagraph;
  begin
    CloseAttr;
    SL.Add(TagEndP);
    IsInPara := False;
  end;

begin
  if Edit.WordWrap then
  begin
    raise Exception.Create('WordWrapTruêƂ͐o͂ł܂B');
  end;

  FontAttr := TFont.Create;
  try
    // wb_ǉ
    SL.Add(Format(TagHTMLHeadder, [Title]));

    CurPos := 0;
    ImgNo := 1;
    InitFont;
    Alignment := paJustify;
    Numbering := nsNone;
    IsInPara := False;
    IsInLink := False;

    // s[v
    for I := 0 to Edit.Lines.Count - 1 do
    begin
      Edit.SelStart := CurPos;
      Edit.SelLength := 0;

      // s̍ŏŁAsŜ̏(ӏAAAE)𔻒f

      // ӏ̐ݒ
      if Numbering <> Edit.Paragraph.Numbering then
      begin
        CloseAttr;
        // ꂽꍇAӏAԍt
        if Edit.Paragraph.Numbering = nsNone then
        begin
          if Numbering = nsBullet then SL[SL.Count-1] := SL[SL.Count-1] + TagEndUL;
          if Numbering = nsArabicNumbers then SL[SL.Count-1] := SL[SL.Count-1] + TagEndOL;
        end;

        // ӏݒ肳ꂽꍇAԍtĉӏݒ
        if Edit.Paragraph.Numbering = nsBullet then
        begin
          if Numbering = nsArabicNumbers then SL[SL.Count-1] := SL[SL.Count-1] + TagEndOL;
          if IsInPara then CloseParagraph;
          SL.Add(TagUL);
        end;

        // ԍtݒ肳ꂽꍇAӏĔԍtݒ
        if Edit.Paragraph.Numbering = nsArabicNumbers then
        begin
          if Numbering = nsBullet then SL[SL.Count-1] := SL[SL.Count-1] + TagEndUL;
          if IsInPara then CloseParagraph;
          SL.Add(TagOL);
        end;

        Numbering := Edit.Paragraph.Numbering;
      end;

      if Numbering <> nsNone then SL[SL.Count-1] := SL[SL.Count-1] + TagList;

      // ʏ̍s(ӏAԍtȊO)̏ꍇ
      if Numbering = nsNone then
      begin
        // //E񂹂̐ݒ
        if Alignment <> Edit.Paragraph.Alignment then
        begin
          CloseAttr;
          if IsInPara then CloseParagraph;
          Alignment := Edit.Paragraph.Alignment;
          if Alignment = JvRichEdit.paLeftJustify then SL.Add(TagLeftP);
          if Alignment = JvRichEdit.paCenter then SL.Add(TagCenterP);
          if Alignment = JvRichEdit.paRightJustify then SL.Add(TagRightP);
          IsInPara := True;
        end;
      end;

      // s̒A1

      L := SL.Count-1;
      for J := 0 to Length(Edit.Lines[I]) -1 do
      begin
        Edit.SelStart := CurPos;
        Edit.SelLength := 1;

        // IuWFNg̏ꍇ
        if stObject in Edit.SelectionType then
        begin
          if FileName <>  '' then
          begin
            CreateImage;
            SL[L] := SL[L] + Format('<img src="./%s-%.5d.jpg" alt="%s-%.5d.jpg">',
              [ChangeFileExt(ExtractFileName(FileName), ''), ImgNo
              ,ChangeFileExt(ExtractFileName(FileName), ''), ImgNo
              ]);
            ImgNo := ImgNo + 1;
          end;
          CurPos := CurPos + 1;
          Continue;
        end;

        // IuWFNgȊȌꍇ(eLXg̏ꍇ)

        // Ō1䕶ǂ(䕶ȂAЂƂǂ)
        if J = Length(Edit.Lines[I]) -1 then
        begin
          GetStringTypeEx(LOCALE_SYSTEM_DEFAULT, CT_CTYPE1, PChar(Edit.SelText), 1, CT);
          if C1_CNTRL = (CT and C1_CNTRL) then Continue;
        end;

        // link^O(NanaTreeƎ^O)
        LinkStr := '';
        if EditorForm.IsNodeLink(Edit, CurPos, LinkStr) then
        begin
          if not IsInLink then
          begin
            IsInLink := True;

            // <nlink>̕菜(-13́A'&lt;nlink&gt;' ̒)
            SL[L] := Copy(SL[L], 0, Length(SL[L]) -13);

            // ɃNĂꍇA̕t@CփN
            if FindNodeFromCaption(LinkStr, Node) then
            begin
              SL[L] := SL[L] +
                Format('<a href="./%.5d.htm">%s</a>', [TreeView.AbsoluteIndex(Node) + 1, LinkStr]);
            end
            // ɃNꍇAʂɃN
            else
            begin
              SL[L] := SL[L] + Format('<a href="%s">%s</a>', [LinkStr, LinkStr]);
            end;
          end;
          CurPos := CurPos + 1;
          Continue;
        end
        else
        begin
          IsInLink := False;
        end;

        // ̈ꕔłωĂꍇAxSĂ̑^O
        if (Script <> Edit.SelAttributes.SubscriptStyle) or   // tt
           (FontAttr.Style <> Edit.SelAttributes.Style) or    // AC^bNAA
           (FontAttr.Name <> Edit.SelAttributes.Name) or      // tHg
           (FontAttr.Color <> Edit.SelAttributes.Color) or    // tHgF
           (FontAttr.Size <> Edit.SelAttributes.Size) then    // tHgTCY
        begin
          CloseAttr;
        end;

        // tAtωĂꍇA^Oǉ
        if Script <> Edit.SelAttributes.SubscriptStyle then
        begin
          // t̏ꍇ
          if Edit.SelAttributes.SubscriptStyle = ssSuperscript then
          begin
            CloseAttr;
            SL[L] := SL[L] + '<span style="vertical-align: super">';
            Script := ssSuperScript;
            AttrCount := AttrCount + 1;
          end;
          // t̏ꍇ
          if Edit.SelAttributes.SubscriptStyle = ssSubscript then
          begin
            CloseAttr;
            SL[L] := SL[L] + '<span style="vertical-align: sub">';
            Script := ssSubScript;
            AttrCount := AttrCount + 1;
          end;
          // ʏ푮̏ꍇ
          if Edit.SelAttributes.SubscriptStyle = ssNone then
          begin
            CloseAttr;
            Script := ssNone;
          end;
        end;

        // tHgAFATCYωĂꍇA^Oǉ
        if (FontAttr.Name <> Edit.SelAttributes.Name) or
           (FontAttr.Color <> Edit.SelAttributes.Color) or
           (FontAttr.Size <> Edit.SelAttributes.Size) then
        begin
          FontAttr.Name := Edit.SelAttributes.Name;
          FontAttr.Color := Edit.SelAttributes.Color;
          FontAttr.Size := Edit.SelAttributes.Size;

          SL[L] := SL[L] + TagSpan;
          SL[L] := SL[L] + Format(StyleFontFamily, [FontAttr.Name]);
          SL[L] := SL[L] + Format(StyleFontColor, [GetHTMLColor(FontAttr.Color)]);
          if Script <> ssNone then
          begin
            SL[L] := SL[L] + Format(StyleFontSize, [IntToStr(FontAttr.Size * 3 div 4)]);
          end
          else
          begin
            SL[L] := SL[L] + Format(StyleFontSize, [IntToStr(FontAttr.Size)]);
          end;
          SL[L] := SL[L] + TagEndTag;
          AttrCount := AttrCount + 1;
        end;

        // AC^bNAAωĂA^Oǉ
        if FontAttr.Style <> Edit.SelAttributes.Style then
        begin
          if fsBold in Edit.SelAttributes.Style then
          begin
            SL[L] := SL[L] + '<span style="font-weight: bold;">';
            AttrCount := AttrCount + 1;
          end;

          if fsItalic in Edit.SelAttributes.Style then
          begin
            SL[L] := SL[L] + '<span style="font-style: italic;">';
            AttrCount := AttrCount + 1;
          end;

          if fsUnderline in Edit.SelAttributes.Style then
          begin
            SL[L] := SL[L] + '<span style="text-decoration: underline;">';
            AttrCount := AttrCount + 1;
          end;

          if fsStrikeOut in Edit.SelAttributes.Style then
          begin
            SL[L] := SL[L] + '<span style="text-decoration: line-through;">';
            AttrCount := AttrCount + 1;
          end;

          FontAttr.Style := Edit.SelAttributes.Style;
        end;

        // HTMLł̋֎~ϊāAǉ
        SL[L] := SL[L] + ReplaceSpecialString(Edit.SelText);
        CurPos := CurPos + 1;
      end;

      // ӏAԍt̍sȂAs̍Ō<li>
      if (Numbering = nsBullet) or (Numbering = nsArabicNumbers) then
      begin
        CloseAttr;
        SL[L] := SL[L] + TagEndList;
      end
      else
      begin
        SL[L] := SL[L] + TagBR;
      end;

      CurPos := CurPos + 1;
    end;

    // ŌɎc^Ȍ

    // 
    CloseAttr;

    // ӏAԍt
    if Numbering = nsBullet then
      SL[SL.Count-1] := SL[SL.Count-1] + TagEndUL;
    if Numbering = nsArabicNumbers then
      SL[SL.Count-1] := SL[SL.Count-1] + TagEndOL;

    // i
    if IsInPara then CloseParagraph;

    SL.Add(TagHTMLFooter);
  finally
    FontAttr.Free;
  end;
end;


//----------------------------------------
// FI_CAO\
//----------------------------------------
procedure TMainForm.ItemOtherColorClick(Sender: TObject);
begin
  ColorDialog.Color := ColorPalette.Color;
  if ColorDialog.Execute then
  begin
    ColorPalette.Color := ColorDialog.Color;
    SubmenuItemColor.Invalidate;
  end;
end;


//----------------------------------------
// ̐FNbN
//----------------------------------------
procedure TMainForm.ItemDefaultColorClick(Sender: TObject);
begin
    ColorPalette.Color := Editor.Font.Color;
    SubmenuItemColor.Invalidate;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FStream.Free;
end;

end.
