program NanaTree;

{$R 'manifest.res' 'manifest.rc'}

uses
  FastMM4,
  Forms,
  FormMain in 'FormMain.pas' {MainForm},
  FormTree in 'FormTree.pas' {TreeForm},
  FormEditor in 'FormEditor.pas' {EditorForm},
  ModuleGlobal in 'ModuleGlobal.pas' {GlobalModule: TDataModule},
  DlgAbout in 'DlgAbout.pas' {AboutDlg},
  DlgInsertTable in 'DlgInsertTable.pas' {InsertTableDlg},
  FormPrintPreview in 'FormPrintPreview.pas' {PrintPreviewForm},
  DlgSort in 'DlgSort.pas' {SortDlg},
  DlgSetting in 'DlgSetting.pas' {SettingDlg},
  DlgEditFontStyle in 'DlgEditFontStyle.pas' {EditFontStyleDlg},
  DlgInputKey in 'DlgInputKey.pas' {InputKeyDlg},
  DlgKeyBind in 'DlgKeyBind.pas' {KeyBindDlg},
  DlgFind in 'DlgFind.pas' {FindDlg};

{$R *.res}

begin
  Application.Initialize;
  Application.Title := 'NanaTree';
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TTreeForm, TreeForm);
  Application.CreateForm(TEditorForm, EditorForm);
  Application.CreateForm(TGlobalModule, GlobalModule);
  Application.CreateForm(TFindDlg, FindDlg);
  Application.Run;
end.
